// Written in the D programming language

/*
 *	This file has been automatically generated by APaGeD v0.5 beta - Attributed Parser Generator for D.
 *
 *	Sections generated from custom input are marked as "generated code" and
 *	are subject to the terms and conditions stated in one of these sections.
 *	The remaining sections are part of the APaGeD package and subject
 *	to the terms and conditions of the corresponding license.
 *
 *	Attributed Parser Generator for D
 *	Copyright (c) 2007-2008 Jascha Wetzel. All rights reserved
 *	License: Artistic License 2.0
 */

// generated code start

module expression.expression_apd;

import codeview.decl;
import codeview.codeview;
import expression.evaluationcontext;
import expression.datahandler;
import util;

import internal.aaA;

import std.demangle;
import std.stdio;

import win32.winnt;

/**********************************************************************************************

**********************************************************************************************/
bool castArrayIndex(ubyte[] data, string type, out size_t index)
{
	assert(type.length>0);
	switch ( type[0] )
	{
		case 'a':
			if ( *cast(char*)data.ptr < 0 )
				throw new EvaluationException("Cannot access array with negative index");
		case 'h':
			index = *cast(ubyte*)data.ptr;
			return true;
		case 's':
			if ( *cast(short*)data.ptr < 0 )
				throw new EvaluationException("Cannot access array with negative index");
		case 't':
			index = *cast(ushort*)data.ptr;
			return true;
		case 'i':
			if ( *cast(int*)data.ptr < 0 )
				throw new EvaluationException("Cannot access array with negative index");
		case 'k':
			index = *cast(uint*)data.ptr;
			return true;
		case 'l':
			if ( *cast(long*)data.ptr < 0 )
				throw new EvaluationException("Cannot access array with negative index");
		case 'm':
			index = cast(size_t)*cast(ulong*)data.ptr;
			return true;
		default:
	}
	return false;
}

/**********************************************************************************************

**********************************************************************************************/
//	  debug = parser;
unittest
{
	bool test(string expr)
	{
		SyntaxTree* root;
		bool success;
		try success = parse(expr, root);
		catch ( ParserException e ) {
			debug(parser) writefln("%s", e.toString);
			return false;
		}
		return success;
	}

	assert(test("a.bc"));
	assert(test("bc[def..ghij]"));
	assert(!test("\"a\\\"\\\u2f85qwe '\""));
	assert(test("a.bc[def..ghij].klmno.pqrstu[0..'a'][\"a\\\"\\u2f85qwe '\"]"));
	assert(!test("a.bc.[def..ghij]"));
	assert(!test("[def..ghij]"));
	assert(!test("a."));
	assert(test("asdf[0][i].qwer"));
	assert(test("cast(uint)asdf"));
	assert(test("(cast(mystruct)asdf).qwer"));
	assert(test("(cast(string[])asdf)[0][2..13]"));
	assert(test("(cast(char[string])asdf)[\"qwer\"]"));
	assert(!test("(cast(mystruct)asdf).(cast(char[][])qwer)[0]"));
	assert(test("cast(float)asdf.qwer"));
	assert(!test("cast.qwer"));
	assert(!test("cast(uint).qwer"));
	assert(!test("cast(asdf.qwer).qwer"));
	assert(test("(cast(string)mystruct.tzui)[0..4]"));
	assert(test("cast(Vec!(float,3))mystruct"));
	assert(test("cast(Vec!(float,3,\"asdf\",Vec!(float)))mystruct"));
	assert(test("vertices[inds[10193]].y"));
	assert(test("*cast(uint*)#eax"));
}
// generated code end

version(Tango)
{

}
else
{
	import std.string;
	debug import std.stdio;
}

/**************************************************************************************************
	Semantic Analyzer
**************************************************************************************************/

class SemanticException : Exception
{
	this(string msg)
	{
		super(msg);
	}
}

class SyntaxTree
{
	ushort			_ST_rule,
					_ST_column_number;
	uint			_ST_line_number;

	debug
	{
		string			_ST_node_name,
						_ST_match,
						_ST_match_ws;
		SyntaxTree[]	_ST_children;
	}
	else
	{
		union
		{
			struct {
				string		_ST_match,
							_ST_match_ws;
			}
			struct {
				SyntaxTree[]	_ST_children;
				size_t[2]		_ST_pad;
			}
		}
	}

	bool isTerminal()
	{
		debug	return _ST_match_ws !is null;
		else	return _ST_pad[0] == 0 && _ST_pad[1] == 0;
	}

	debug
	{
		SyntaxTree parent;

		string indent()
		{
			string str;
			for ( SyntaxTree n = parent; n !is null; n = n.parent )
				str ~= "  ";
			return str;
		}

		void print(string indent = "")
		{
			version(Tango)
				Trace.format("{}{}{}", indent, _ST_node_name, _ST_rule);
			else
				writef("%s%s%d", indent, _ST_node_name, _ST_rule);
			if ( _ST_children.length == 0 )
			{
				version(Tango)
					Trace.formatln(" (\"{}\")", _ST_match);
				else
					writefln(" (\"%s\")", _ST_match);
			}
			else
			{
				version(Tango)
					Trace.formatln("");
				else
					writefln;
			}
			foreach ( c; _ST_children )
				c.print(indent~"  ");
		}
	}

	void opCatAssign(SyntaxTree n)
	{
		_ST_children ~= n;
	}

	// augmented semantic code
// generated code start
	alias _S_Expr_default Expr;
final void _S_Expr_default(EvaluationContext ctx, out SymbolData symdata)
{

	switch ( _ST_rule )
	{

	case 0:
		auto Deref_node = _ST_children[0];
		auto Deref = &Deref_node._S_Deref_default;
		auto Cast_node = _ST_children[1];
		auto Cast = &Cast_node._S_Cast_default;
		auto DotChain_node = _ST_children[2];
		auto DotChain = &DotChain_node._S_DotChain_default;

		DotChain(ctx, symdata);
		Cast(ctx, symdata);
		Deref(ctx, symdata);
		break;
	default:
		assert(0, "Unexpected rule index "~std.string.toString(_ST_rule)~" in Expr_default");
	}
}
final void _S_Deref_default(EvaluationContext ctx, ref SymbolData symdata)
{

	switch ( _ST_rule )
	{

	case 1:
		auto Deref_node = _ST_children[0];
		auto Deref = &Deref_node._S_Deref_default;

		if ( symdata is null )
			throw new EvaluationException("Invalid data for dereferencing");
		if ( symdata.type[0] != 'P' )
			throw new EvaluationException("Cannot dereference non-pointer of type "~demangleType(symdata.type));
		symdata.type = symdata.type[1..$];
		assert(symdata.type.length>0);
		ubyte[] data = symdata.getData(ctx);
		if ( data.length != size_t.sizeof ) {
			throw new EvaluationException("Invalid pointer data size = "~.toString(data.length));
		}
		symdata.ptr = (cast(size_t[])data)[0];
		symdata.len = ctx.codeView.sizeofMangled(symdata.type);
		symdata.defered_load = true;

		Deref(ctx, symdata);
		break;
	case 2:
		break;
	default:
		assert(0, "Unexpected rule index "~std.string.toString(_ST_rule)~" in Deref_default");
	}
}
final void _S_DotChain_default(EvaluationContext ctx, out SymbolData symdata)
{

	switch ( _ST_rule )
	{

	case 6:
		auto Lit_node = _ST_children[0];
		auto Lit = &Lit_node._S_Lit_default;
 Lit(symdata);
		break;

	case 5:
		auto Ident_node = _ST_children[0];
		auto Ident = &Ident_node._S_Ident_default;
		auto RefExpr_node = _ST_children[1];
		auto RefExpr = &RefExpr_node._S_RefExpr_default;

		string id;
		Ident(id);

		NamedSymbol[] symbols;
		NamedSymbol symbol = ctx.findSymbol(id, symbols);
		if ( symbol !is null )
			symdata = ctx.loadSymbolData(symbol);
		else
			debug DbgIO.println("symbol %s not found", id);
		RefExpr(ctx, symbol, symbols, id, symdata);
		break;

	case 4:
		auto Expr_node = _ST_children[0];
		auto Expr = &Expr_node._S_Expr_default;
		auto RefExpr_node = _ST_children[1];
		auto RefExpr = &RefExpr_node._S_RefExpr_default;

		Expr(ctx, symdata);
		RefExpr(ctx, null, null, "", symdata);
		break;

	case 3:
		auto Register_node = _ST_children[0];
		auto Register = &Register_node._S_Register_default;

		Register(ctx, symdata);
		break;
	default:
		assert(0, "Unexpected rule index "~std.string.toString(_ST_rule)~" in DotChain_default");
	}
}
final void _S_RefExpr_default(EvaluationContext ctx, NamedSymbol symbol, NamedSymbol[] symbols, string prefix, ref SymbolData symdata)
{

	switch ( _ST_rule )
	{

	case 9:

		if ( symdata is null )
			throw new EvaluationException("Unknown symbol "~prefix);
		break;

	case 8:
		auto Args_node = _ST_children[0];
		auto Args = &Args_node._S_Args_default;
		auto RefExpr_node = _ST_children[1];
		auto RefExpr = &RefExpr_node._S_RefExpr_default;

		if ( symdata is null )
			throw new EvaluationException("Unknown symbol "~prefix);

		SymbolData	argdata;
		size_t		start, end;
		Args(ctx, argdata, start, end);

		bool isIndex = argdata is null;
		if ( !isIndex && castArrayIndex(argdata.getData(ctx), argdata.type, start) ) {
			isIndex = true;
			end = start+1;
		}

		switch ( symdata.type[0] )
		{
			//---------------------------------------------------------------------------------
			// primitive types
			case 'v': case 'b': case 'x': case 'g': case 'h': case 's': case 't': case 'i': case 'k': case 'l': case 'm': case 'f':
			case 'd': case 'e': case 'o': case 'p': case 'j': case 'q': case 'r': case 'c': case 'a': case 'u': case 'w':
			// pointers, classes/structs
			case 'P': case 'C': case 'S':
				throw new EvaluationException(
					"Type mismatch - unexpected [] operator after expression of type "~demangleType(symdata.type)
				);
			//---------------------------------------------------------------------------------
			// static arrays
			case 'G':
				if ( !isIndex )
					throw new EvaluationException("Cannot access static array with index type "~demangleType(argdata.type));

				symdata.type = symdata.type[1..$];
				size_t count = parseNumber(symdata.type);
				assert(symdata.type.length>0);

				if ( end-start > 1 )
				{
					if ( end > count )
						throw new EvaluationException("Array index out of bounds: "~.toString(start)~".."~.toString(end)~" ($="~.toString(count)~")");
					size_t size = ctx.codeView.sizeofMangled(symdata.type);
					if ( symdata.defered_load ) {
						symdata.ptr += start * size;
						symdata.len = (end-start) * size;
					}
					else
						symdata.data = symdata.data[start*size .. end*size];
					symdata.type = "G"~.toString(end-start)~symdata.type;
				}
				else
				{
					if ( !symdata.loadElementSlice(start, end, ctx.codeView) )
						throw new EvaluationException("Array index out of bounds: "~.toString(start)~".."~.toString(end)~" ($="~.toString(count)~")");
				}
				break;
			//---------------------------------------------------------------------------------
			// dynamic arrays
			case 'A':
				if ( !isIndex )
					throw new EvaluationException("Cannot access dynamic array with index type "~demangleType(argdata.type));

				ubyte[] data = symdata.getData(ctx);
				if ( data.length < 8 )
					throw new EvaluationException("Subexpression evaluated to empty data");

				if ( end-start > 1 )
				{
					if ( end > (cast(size_t[])data)[0] )
						throw new EvaluationException("Array index out of bounds: "~.toString(start)~".."~.toString(end)~" ($="~.toString(symdata.len)~")");
					size_t size = ctx.codeView.sizeofMangled(symdata.type[1..$]);
					(cast(size_t[])data)[1] += start * size,
					(cast(size_t[])data)[0] = end-start;
				}
				else
				{
					symdata.type = symdata.type[1..$];
					assert(symdata.type.length>0);
					symdata.ptr = (cast(size_t[])data)[1];
					symdata.len = (cast(size_t[])data)[0] * ctx.codeView.sizeofMangled(symdata.type);
					symdata.defered_load = true;

					if ( !symdata.loadElementSlice(start, end, ctx.codeView) )
						throw new EvaluationException("Array index out of bounds: "~.toString(start)~".."~.toString(end)~" ($="~.toString(symdata.len)~")");
				}
				break;
			//---------------------------------------------------------------------------------
			// associative arrays
			case 'H':
				int i;
				for ( i = 1; i < symdata.type.length && std.string.find(lowercase, symdata.type[i]) < 0; ++i ) {}
				string		key_type	= symdata.type[1..i+1],
							val_type	= symdata.type[i+1..$];
				size_t		val_tsize	= ctx.codeView.sizeofMangled(val_type);
				TypeInfo	key_ti		= TypeInfoFromMangled(key_type);

				aaA* loadaaA(void* ptr)
				{
					if ( ptr is null )
						return null;
					ubyte[] data;
					data.length = aaA.sizeof+key_ti.tsize+val_tsize;
					if ( data.length != ctx.process.readProcessMemory(cast(uint)ptr, data.ptr, data.length) )
						return null;
					aaA* a = cast(aaA*)data.ptr;
					if ( std.string.find(lowercase, key_type[0]) < 0 )
					switch ( key_type[0] )
					{
						case 'A':
							ubyte[] tmp = *cast(ubyte[]*)(a+1);
							if ( tmp.length > ctx.process.MEMCHECK_MIN && ctx.process.isInvalidMem(cast(size_t)tmp.ptr, tmp.length) )
								return null;
							data = new ubyte[tmp.length];
							if ( data.length != ctx.process.readProcessMemory(cast(size_t)tmp.ptr, data.ptr, data.length) )
								return null;
							*cast(ubyte[]*)(a+1) = data;
							break;
						case 'P':
							break;
						default:
							throw new EvaluationException("only basic, pointer and array key types are supported, yet");
					}
					return a;
				}

				ubyte[] findKey(size_t ptr, hash_t hash, ubyte[] key_data)
				{
					ubyte[] data;
					data.length = BB.sizeof;
					if ( data.length != ctx.process.readProcessMemory(ptr, data.ptr, data.length) )
						return null;
					BB* bb = cast(BB*)data.ptr;
					size_t blen = bb.b.length*size_t.sizeof;
					debug(eval) DbgIO.println("%d nodes, bb.b.length=%d", bb.nodes, bb.b.length);

					if ( blen > ctx.process.MEMCHECK_MIN && ctx.process.isInvalidMem(cast(size_t)bb.b.ptr, blen) )
						return null;
					data = new ubyte[blen];
					if ( data.length != ctx.process.readProcessMemory(cast(uint)bb.b.ptr, data.ptr, data.length) )
						return null;
					bb.b = cast(aaA*[])data;

					uint i = hash % bb.b.length;
					debug(eval) DbgIO.println("start index=%d", i);
					aaA* a = loadaaA(bb.b[i]);
					while ( a !is null )
					{
						if ( hash == a.hash )
						{
							debug(eval) DbgIO.println("equal 0x%x", a.hash);
							auto cmp = key_ti.compare(key_data.ptr, a+1);
							debug(eval) DbgIO.println("%s: %d == %d -> %d", key_ti, *cast(uint*)key_data.ptr, *cast(uint*)(a+1), cmp);
							if ( cmp == 0 )
								return ((cast(ubyte*)(a+1))+key_ti.tsize)[0 .. val_tsize];
							a = cmp < 0 ? loadaaA(a.left) : loadaaA(a.right);
						}
						else {
							debug(eval) DbgIO.println("not equal 0x%x", a.hash);
							a = hash < a.hash ? loadaaA(a.left) : loadaaA(a.right);
						}
					}
					return null;
				}

				if ( key_type != argdata.type )
					throw new EvaluationException("Invalid key type for associative array. Expected "~demangleType(key_type)~" found "~demangleType(argdata.type));
				TypeInfo ti = TypeInfoFromMangled(argdata.type);
				hash_t index_hash = ti.getHash(argdata.data.ptr);

				debug(eval) DbgIO.println("searching, hash=0x%x", index_hash);
				ubyte[] data = symdata.getData(ctx);
				symdata.data = findKey((cast(size_t[])data)[0], index_hash, argdata.getData(ctx));
				symdata.type = val_type;
				break;
			//---------------------------------------------------------------------------------
			// unsupported
			default:
				throw new EvaluationException("yet unsupported type "~demangleType(symdata.type)~" in expression");
		}

		RefExpr(ctx, symbol, null, null, symdata);
		break;

	case 7:
		auto Ident_node = _ST_children[0];
		auto Ident = &Ident_node._S_Ident_default;
		auto RefExpr_node = _ST_children[1];
		auto RefExpr = &RefExpr_node._S_RefExpr_default;

		string id;
		Ident(id);
		prefix ~= "."~id;

		if ( symdata is null )
		{
			symbol = ctx.findSymbol(prefix, symbols);
			if ( symbol !is null )
				symdata = ctx.loadSymbolData(symbol);
		}
		else
		{
			switch ( symdata.type[0] )
			{
				//---------------------------------------------------------------------------------
				// primitive types
				case 'v': case 'b': case 'x': case 'g': case 'h': case 's': case 't': case 'i': case 'k': case 'l': case 'm': case 'f':
				case 'd': case 'e': case 'o': case 'p': case 'j': case 'q': case 'r': case 'c': case 'a': case 'u': case 'w':
					throw new EvaluationException(
						"Type mismatch - unexpected . operator in expression of type "~demangleType(symdata.type)
					);
				//---------------------------------------------------------------------------------
				// array properties
				case 'G':
					switch ( id )
					{
						case "length":
							symdata.type = symdata.type[1..$];
							size_t len = parseNumber(symdata.type);
							symdata.type = "k";
							symdata.data = (cast(ubyte*)&len)[0..size_t.sizeof].dup;
							symdata.defered_load = false;
							break;
						case "ptr":
							// TODO: can this always be guaranteed?
							assert(symdata.defered_load);
							size_t ptr = symdata.ptr;
							symdata.data = (cast(ubyte*)&ptr)[0..size_t.sizeof];
							symdata.defered_load = false;
							symdata.type = symdata.type[1..$];
							parseNumber(symdata.type);
							symdata.type = "P"~symdata.type;
							break;
						default:
							throw new EvaluationException(
								"Type mismatch - invalid property "~id~" after expression of type "~demangleType(symdata.type)
							);
					}
					break;
				case 'A':
					switch ( id )
					{
						case "length":
							ubyte[] data = symdata.getData(ctx);
							symdata.type = "k";
							size_t len = (cast(size_t[])data)[0];
							symdata.data = (cast(ubyte*)&len)[0..size_t.sizeof].dup;
							symdata.defered_load = false;
							break;
						case "ptr":
							ubyte[] data = symdata.getData(ctx);
							symdata.type = "k";
							size_t len = (cast(size_t[])data)[1];
							symdata.data = (cast(ubyte*)&len)[0..size_t.sizeof].dup;
							symdata.defered_load = false;
							break;
						default:
							throw new EvaluationException(
								"Type mismatch - invalid property "~id~" after expression of type "~demangleType(symdata.type)
							);
					}
					break;
				case 'H':
					switch ( id )
					{
						case "length":
							ubyte[] data = symdata.getData(ctx);
							symdata.ptr = *cast(size_t*)data.ptr;
							symdata.len = BB.sizeof;
							symdata.defered_load = true;
							data = symdata.getData(ctx);
							BB* bb = cast(BB*)data.ptr;

							symdata.type = "k";
							symdata.data = (cast(ubyte*)&bb.nodes)[0..size_t.sizeof].dup;
							symdata.defered_load = false;
							break;
						default:
							throw new EvaluationException(
								"Type mismatch - invalid property "~id~" after expression of type "~demangleType(symdata.type)
							);
					}
					break;
				//---------------------------------------------------------------------------------
				// references to structs/classes
				case 'P':
					symdata.type = symdata.type[1..$];
					if ( symdata.type[0] != 'C' && symdata.type[0] != 'S' )
					{
						throw new EvaluationException(
							"Type mismatch - unexpected . operator after expression of type "~demangleType("P"~symdata.type)
						);
					}

					ubyte[] data = symdata.getData(ctx);
					if ( symdata.data.length <= 0 )
						throw new EvaluationException("Subexpression evaluated to empty data");
					symdata.ptr = (cast(uint[])data)[0];
					symdata.len = ctx.codeView.sizeofMangled(symdata.type);
					symdata.defered_load = true;

					if ( symdata.ptr == 0 )
						throw new EvaluationException("pointer is null");
					// fall through to struct handling

				//---------------------------------------------------------------------------------
				// classes/structs
				case 'C':
				case 'S':
					symdata.type = symdata.type[1..$];
					string	scu_name = demangleNameSkip(symdata.type);
					assert ( symdata.type.length <= 0 );
					if ( (scu_name in ctx.codeView.UDTsByName) is null )
						throw new EvaluationException("unknown type \""~scu_name~"\"");

					LeafClassStruc	lcs = cast(LeafClassStruc)ctx.codeView.UDTsByName[scu_name];
					LeafUnion		lu;
					LeafFieldList	lfl;
					uint			type_length;

					if ( lcs !is null && lcs.field-0x1000 < ctx.codeView.type_strings.length ) {
						Leaf[] fields = ctx.codeView.type_strings[lcs.field-0x1000];
						lfl = cast(LeafFieldList)fields[0];
						type_length = lcs.length.getUint();
					}
					else
					{
						lu = cast(LeafUnion)ctx.codeView.UDTsByName[scu_name];
						if ( lu !is null && lu.field-0x1000 < ctx.codeView.type_strings.length ) {
							Leaf[] fields = ctx.codeView.type_strings[lu.field-0x1000];
							lfl = cast(LeafFieldList)fields[0];
							type_length = lu.length.getUint();
						}
					}
					if ( lfl is null )
						throw new EvaluationException("invalid struct/class debug symbols");

					size_t	size,
							offset;
					if ( !ctx.findMember(id, lfl, size, offset, symdata.type) )
						throw new EvaluationException("struct \""~scu_name~"\" has no element \""~id~"\"");
					assert ( symdata.type.length > 0 );
					debug(eval) DbgIO.println("member: type=%s size=%d offset=%d", symdata.type, size, offset);

					if ( !symdata.loadByteSlice(offset, offset+size) )
						throw new EvaluationException("invalid offset into struct for member \""~id~"\"");
					break;
				//---------------------------------------------------------------------------------
				// unsupported
				default:
					throw new EvaluationException("yet unsupported type "~demangleType(symdata.type)~" in expression");
			}
		}

		RefExpr(ctx, symbol, symbols, prefix, symdata);
		break;
	default:
		assert(0, "Unexpected rule index "~std.string.toString(_ST_rule)~" in RefExpr_default");
	}
}
final void _S_Args_default(EvaluationContext ctx, out SymbolData argdata, out size_t start, out size_t end)
{

	switch ( _ST_rule )
	{

	case 11:
		auto Expr_node = _ST_children[0];
		auto Expr = &Expr_node._S_Expr_default;
 Expr(ctx, argdata);
		break;

	case 10:
		auto Expr_node = _ST_children[0];
		auto Expr = &Expr_node._S_Expr_default;
		auto Expr2_node = _ST_children[1];
		auto Expr2 = &Expr2_node._S_Expr_default;

		SymbolData arg1, arg2;
		Expr(ctx, arg1);
		Expr2(ctx, arg2);

		bool isIndex = castArrayIndex(arg1.getData(ctx), arg1.type, start);
		isIndex = isIndex && castArrayIndex(arg2.getData(ctx), arg2.type, end);
		if ( !isIndex )
			throw new EvaluationException("Slices may only have integer indeces, not "~demangleType(arg1.type)~".."~demangleType(arg2.type));
		break;
	default:
		assert(0, "Unexpected rule index "~std.string.toString(_ST_rule)~" in Args_default");
	}
}
final void _S_Register_default(EvaluationContext ctx, out SymbolData symdata)
{

	switch ( _ST_rule )
	{

	case 12:
		auto RegName_node = _ST_children[0];
		auto RegName = &RegName_node._S_RegName_default;

		string	name;
		ubyte	width;
		RegName(name, width);

		CONTEXT threadCtx;
		uint context_flags;
		context_flags |= CONTEXT_FULL;
		context_flags |= CONTEXT_FLOATING_POINT;
		context_flags |= CONTEXT_EXTENDED_REGISTERS;
		if ( !ctx.getContext(threadCtx, context_flags) )
			throw new EvaluationException("Couldn't get main thread's context");

		ubyte* ptr;
		switch ( name[1..$] )
		{
			case "ax":
			case "eax":
			case "al":	ptr = cast(ubyte*)&threadCtx.Eax;	break;
			case "ah":	ptr = (cast(ubyte*)&threadCtx.Eax)+1;	break;
			case "bx":
			case "ebx":
			case "bl":	ptr = cast(ubyte*)&threadCtx.Ebx;	break;
			case "bh":	ptr = (cast(ubyte*)&threadCtx.Ebx)+1;	break;
			case "cx":
			case "ecx":
			case "cl":	ptr = cast(ubyte*)&threadCtx.Ecx;	break;
			case "ch":	ptr = (cast(ubyte*)&threadCtx.Ecx)+1;	break;
			case "dx":
			case "edx":
			case "dl":	ptr = cast(ubyte*)&threadCtx.Edx;	break;
			case "dh":	ptr = (cast(ubyte*)&threadCtx.Edx)+1;	break;
			case "edi":
			case "di":	ptr = cast(ubyte*)&threadCtx.Edi;	break;
			case "esi":
			case "si":	ptr = cast(ubyte*)&threadCtx.Esi;	break;
			case "ebp":
			case "bp":	ptr = cast(ubyte*)&threadCtx.Ebp;	break;
			case "esp":
			case "sp":	ptr = cast(ubyte*)&threadCtx.Esp;	break;
			case "eip": ptr = cast(ubyte*)&threadCtx.Eip;	break;
			case "efl": ptr = cast(ubyte*)&threadCtx.EFlags;	break;
			case "cs":	ptr = cast(ubyte*)&threadCtx.SegCs; break;
			case "ds":	ptr = cast(ubyte*)&threadCtx.SegDs; break;
			case "es":	ptr = cast(ubyte*)&threadCtx.SegEs; break;
			case "fs":	ptr = cast(ubyte*)&threadCtx.SegFs; break;
			case "gs":	ptr = cast(ubyte*)&threadCtx.SegGs; break;
			default:
				int i = name[$-1]-'0';
				if ( name[0..2] == "st" )
					ptr = cast(ubyte*)&((cast(real[])threadCtx.FloatSave.RegisterArea)[i]);
				else if ( name[0..2] == "mm" )
					ptr = cast(ubyte*)&((cast(long[])threadCtx.ExtendedRegisters)[4+i*2]);
				else if ( name[0..3] == "xmm" )
					ptr = cast(ubyte*)&((cast(long[])threadCtx.ExtendedRegisters)[20+i*2]);
				else
					assert(0);
		}

		symdata = new SymbolData;
		switch ( width )
		{
			case 8:
				symdata.type = "h";
				symdata.data = ptr[0..1].dup;
				break;
			case 16:
				symdata.type = "t";
				symdata.data = ptr[0..2].dup;
				break;
			case 32:
				symdata.type = "k";
				symdata.data = ptr[0..4].dup;
				break;
			case 64:
				symdata.type = "m";
				symdata.data = ptr[0..8].dup;
				break;
			case 80:
				symdata.type = "e";
				symdata.data = ptr[0..10].dup;
				break;
			case 128:
				symdata.type = "G4k";
				symdata.data = ptr[0..16].dup;
				break;
			default:
				assert(0, "unhandled register width "~.toString(width));
		}
		break;
	default:
		assert(0, "Unexpected rule index "~std.string.toString(_ST_rule)~" in Register_default");
	}
}
final void _S_RegName_default(out string name, out ubyte width)
{

	switch ( _ST_rule )
	{

	case 18:
 name = _ST_match; width = 128;
		break;

	case 17:
 name = _ST_match; width = 64;
		break;

	case 16:
 name = _ST_match; width = 8*real.sizeof;
		break;

	case 15:
 name = _ST_match; width = 8;
		break;

	case 14:
 name = _ST_match; width = 16;
		break;

	case 13:
 name = _ST_match; width = 32;
		break;
	default:
		assert(0, "Unexpected rule index "~std.string.toString(_ST_rule)~" in RegName_default");
	}
}
final void _S_Cast_default(EvaluationContext ctx, ref SymbolData symdata)
{

	switch ( _ST_rule )
	{

	case 19:
		auto Type_node = _ST_children[0];
		auto Type = &Type_node._S_Type_default;

		symdata.type = "";
		Type(ctx, symdata.type);
		if ( symdata.type.length <= 0 )
			throw new EvaluationException("Unknown type in cast");
		break;
	case 20:
		break;
	default:
		assert(0, "Unexpected rule index "~std.string.toString(_ST_rule)~" in Cast_default");
	}
}
final void _S_Type_default(EvaluationContext ctx, ref string mangled)
{

	switch ( _ST_rule )
	{

	case 21:
		auto BaseType_node = _ST_children[0];
		auto BaseType = &BaseType_node._S_BaseType_default;
		auto QuantList_node = _ST_children[1];
		auto QuantList = &QuantList_node._S_QuantList_default;

		string	unmangled;
		BaseType(ctx, unmangled);

		switch ( unmangled )
		{
			case "void":	mangled = "v";	break;
			case "bool":	mangled = "b";	break;
			case "byte":	mangled = "g";	break;
			case "ubyte":	mangled = "h";	break;
			case "char":	mangled = "a";	break;
			case "wchar":	mangled = "u";	break;
			case "dchar":	mangled = "w";	break;
			case "short":	mangled = "s";	break;
			case "ushort":	mangled = "t";	break;
			case "int": 	mangled = "i";	break;
			case "uint":	mangled = "k";	break;
			case "long":	mangled = "l";	break;
			case "ulong":	mangled = "m";	break;
			case "float":	mangled = "f";	break;
			case "double":	mangled = "d";	break;
			case "real":	mangled = "e";	break;
			default:
				Leaf lf;
				if ( (unmangled in ctx.codeView.UDTsByName) is null )
				{
					foreach ( un, l; ctx.codeView.UDTsByName )
					{
						if ( std.string.find(un, "."~unmangled) > 0 ) {
							lf = l;
							break;
						}
					}
				}
				else
					lf = ctx.codeView.UDTsByName[unmangled];

				if ( lf !is null )
				{
					string fqn;
					switch ( lf.leaf_index )
					{
						case LF_CLASS_16t:
							mangled = "C";
							fqn = (cast(LeafClassStruc)lf).name;
							break;
						case LF_STRUCTURE_16t:
							mangled = "S";
							fqn = (cast(LeafClassStruc)lf).name;
							break;
						case LF_ENUM_16t:
							mangled = "E";
							fqn = (cast(LeafEnum)lf).name;
							break;
						default:
							assert(0);
					}
					string[] parts = std.string.split(fqn, ".");
					foreach ( p; parts ) {
						mangled ~= .toString(p.length);
						mangled ~= p;
					}
				}
				else
					throw new EvaluationException("Unknown BaseType "~unmangled);
				break;
		}

		QuantList(ctx, mangled);
		break;
	default:
		assert(0, "Unexpected rule index "~std.string.toString(_ST_rule)~" in Type_default");
	}
}
final void _S_BaseType_default(EvaluationContext ctx, out string type)
{

	switch ( _ST_rule )
	{

	case 22:
		auto FQNIdent_node = _ST_children[0];
		auto FQNIdent = &FQNIdent_node._S_FQNIdent_default;
		auto TplParams_node = _ST_children[1];
		auto TplParams = &TplParams_node._S_TplParams_default;

		FQNIdent(type);
		string str;
		TplParams(ctx, str);
		type ~= str;
		break;
	default:
		assert(0, "Unexpected rule index "~std.string.toString(_ST_rule)~" in BaseType_default");
	}
}
final void _S_QuantList_default(EvaluationContext ctx, ref string mangled)
{

	switch ( _ST_rule )
	{

	case 23:
		auto Quantifier_node = _ST_children[0];
		auto Quantifier = &Quantifier_node._S_Quantifier_default;
		auto QuantList_node = _ST_children[1];
		auto QuantList = &QuantList_node._S_QuantList_default;

		Quantifier(ctx, mangled);
		QuantList(ctx, mangled);
		break;
	case 24:
		break;
	default:
		assert(0, "Unexpected rule index "~std.string.toString(_ST_rule)~" in QuantList_default");
	}
}
final void _S_Quantifier_default(EvaluationContext ctx, ref string mangled)
{

	switch ( _ST_rule )
	{

	case 28:
		auto Type_node = _ST_children[0];
		auto Type = &Type_node._S_Type_default;

		string index_mangled;
		Type(ctx, index_mangled);
		mangled = "H"~index_mangled~mangled;
		break;

	case 27:
		auto Integer_node = _ST_children[0];
		auto Integer = &Integer_node._S_Integer_default;

		ulong len;
		Integer(len);
		mangled = "G"~.toString(len)~mangled;
		break;

	case 26:
 mangled = "A"~mangled;
		break;

	case 25:
 mangled = "P"~mangled;
		break;
	default:
		assert(0, "Unexpected rule index "~std.string.toString(_ST_rule)~" in Quantifier_default");
	}
}
final void _S_TplParams_default(EvaluationContext ctx, out string str)
{

	switch ( _ST_rule )
	{

	case 29:
		auto TplParam_node = _ST_children[0];
		auto TplParam = &TplParam_node._S_TplParam_default;
		auto TplParams2_node = _ST_children[1];
		auto TplParams2 = &TplParams2_node._S_TplParams2_default;

		string tmp;
		TplParam(ctx, tmp);
		str = "!("~tmp;
		TplParams2(ctx, tmp);
		str ~= tmp~")";
		break;
	case 30:
		break;
	default:
		assert(0, "Unexpected rule index "~std.string.toString(_ST_rule)~" in TplParams_default");
	}
}
final void _S_TplParams2_default(EvaluationContext ctx, out string str)
{

	switch ( _ST_rule )
	{

	case 31:
		auto TplParam_node = _ST_children[0];
		auto TplParam = &TplParam_node._S_TplParam_default;
		auto TplParams2_node = _ST_children[1];
		auto TplParams2 = &TplParams2_node._S_TplParams2_default;

		TplParam(ctx, str);
		string tmp;
		TplParams2(ctx, tmp);
		str ~= tmp;
		break;
	case 32:
		break;
	default:
		assert(0, "Unexpected rule index "~std.string.toString(_ST_rule)~" in TplParams2_default");
	}
}
final void _S_TplParam_default(EvaluationContext ctx, out string str)
{

	switch ( _ST_rule )
	{

	case 34:
		auto StrLit_node = _ST_children[0];
		auto StrLit = &StrLit_node._S_StrLit_default;
 StrLit(str);
		break;

	case 33:
		auto Type_node = _ST_children[0];
		auto Type = &Type_node._S_Type_default;
 Type(ctx, str);
		break;
	default:
		assert(0, "Unexpected rule index "~std.string.toString(_ST_rule)~" in TplParam_default");
	}
}
final void _S_Lit_default(out SymbolData litdata)
{

	switch ( _ST_rule )
	{

	case 37:

		litdata = new SymbolData;
		litdata.type = "a";
		litdata.data = cast(ubyte[])_ST_match[0..1];
		break;

	case 36:

		litdata = new SymbolData;
		litdata.type = "Aa";
		litdata.data = cast(ubyte[])_ST_match;
		break;

	case 35:
		auto Sign_node = _ST_children[0];
		auto Sign = &Sign_node._S_Sign_default;
		auto Integer_node = _ST_children[1];
		auto Integer = &Integer_node._S_Integer_default;
		auto IntegerSuffix_node = _ST_children[2];
		auto IntegerSuffix = &IntegerSuffix_node._S_IntegerSuffix_default;

		litdata = new SymbolData;
		IntegerSuffix(litdata.type);
		ulong val;
		Integer(val);

		if ( val > 0x7fffffffffffffff )
			litdata.type = "m";
		else if ( val > 0xffffffff )
			litdata.type = litdata.type[0]=='i'||litdata.type[0]=='l'?"l":"m";
		else if ( val > 0x7fffffff && litdata.type[0] == 'i' )
			litdata.type = "k";

		litdata.data = (cast(ubyte*)&val)[0 .. (litdata.type[0] == 'k' || litdata.type[0] == 'i')?uint.sizeof:ulong.sizeof].dup;
		Sign(litdata);
		break;
	default:
		assert(0, "Unexpected rule index "~std.string.toString(_ST_rule)~" in Lit_default");
	}
}
final void _S_StrLit_default(out string str)
{

	switch ( _ST_rule )
	{

	case 40:
 str = _ST_match;
		break;

	case 39:
 str = _ST_match;
		break;

	case 38:
		auto Integer_node = _ST_children[0];
		auto Integer = &Integer_node._S_Integer_default;

		ulong val;
		Integer(val);
		str = .toString(val);
		break;
	default:
		assert(0, "Unexpected rule index "~std.string.toString(_ST_rule)~" in StrLit_default");
	}
}
final void _S_Ident_default(out string id)
{

	switch ( _ST_rule )
	{

	case 41:
 id = _ST_match;
		break;
	default:
		assert(0, "Unexpected rule index "~std.string.toString(_ST_rule)~" in Ident_default");
	}
}
final void _S_FQNIdent_default(out string id)
{

	switch ( _ST_rule )
	{

	case 43:
		auto FQNIdent_node = _ST_children[0];
		auto FQNIdent = &FQNIdent_node._S_FQNIdent_default;
		auto Ident_node = _ST_children[1];
		auto Ident = &Ident_node._S_Ident_default;

		FQNIdent(id);
		string tmp;
		Ident(tmp);
		id ~= "."~tmp;
		break;

	case 42:
		auto Ident_node = _ST_children[0];
		auto Ident = &Ident_node._S_Ident_default;
 Ident(id);
		break;
	default:
		assert(0, "Unexpected rule index "~std.string.toString(_ST_rule)~" in FQNIdent_default");
	}
}
final void _S_Integer_default(out ulong val)
{

	switch ( _ST_rule )
	{

	case 47:

		foreach ( b; _ST_match ) {
			val *= 10;
			val += b-'0';
		}
		break;

	case 46:

		foreach ( b; _ST_match[1..$] ) {
			val <<= 3;
			val |= b-'0';
		}
		break;

	case 45:

		foreach ( b; _ST_match[2..$] )
		{
			val <<= 1;
			if ( b == '1' )
				val |= 1;
		}
		break;

	case 44:

		foreach ( b; _ST_match[2..$] )
		{
			val <<= 4;
			if ( b > 'F' )
				val |= b-'W';
			else if ( b > '9' )
				val |= b-'7';
			else
				val |= b-'0';
		}
		break;
	default:
		assert(0, "Unexpected rule index "~std.string.toString(_ST_rule)~" in Integer_default");
	}
}
final void _S_IntegerSuffix_default(out string type)
{

	switch ( _ST_rule )
	{

	case 54:
 type = "i";
		break;

	case 53:
 type = "k";
		break;

	case 52:
 type = "l";
		break;

	case 51:
 type = "m";
		break;

	case 50:
 type = "m";
		break;

	case 49:
 type = "m";
		break;

	case 48:
 type = "m";
		break;
	default:
		assert(0, "Unexpected rule index "~std.string.toString(_ST_rule)~" in IntegerSuffix_default");
	}
}
final void _S_Sign_default(ref SymbolData symdata)
{

	switch ( _ST_rule )
	{

	case 55:

		switch ( symdata.type[0] )
		{
			case 'i':
				*cast(int*)symdata.data.ptr = 0-*cast(int*)symdata.data.ptr;
				break;
			case 'k':
				*cast(uint*)symdata.data.ptr = 0-*cast(uint*)symdata.data.ptr;
				break;
			case 'l':
				*cast(long*)symdata.data.ptr = 0-*cast(long*)symdata.data.ptr;
				break;
			case 'm':
				*cast(ulong*)symdata.data.ptr = 0-*cast(ulong*)symdata.data.ptr;
				break;
			default:
				assert(0);
		}
		break;
	case 56:
		break;
	default:
		assert(0, "Unexpected rule index "~std.string.toString(_ST_rule)~" in Sign_default");
	}
}

}


// generated code end

#line 1349 "src\expression\expression_apd.d"
// Written in the D programming language

/*
 *	This file has been automatically generated by APaGeD v0.5 beta - Attributed Parser Generator for D.
 *
 *	Sections generated from custom input are marked as "generated code" and
 *	are subject to the terms and conditions stated in one of these sections.
 *	The remaining sections are part of the APaGeD package and subject
 *	to the terms and conditions of the corresponding license.
 *
 *	Attributed Parser Generator for D
 *	Copyright (c) 2007-2008 Jascha Wetzel. All rights reserved
 *	License: Artistic License 2.0
 */

/**************************************************************************************************
	Lexer
**************************************************************************************************/

version(Tango)
// the following block is stolen from phobos.
// the copyright notice applies for this block only.
{
/*
 *	Copyright (C) 2003-2004 by Digital Mars, www.digitalmars.com
 *	Written by Walter Bright
 *
 *	This software is provided 'as-is', without any express or implied
 *	warranty. In no event will the authors be held liable for any damages
 *	arising from the use of this software.
 *
 *	Permission is granted to anyone to use this software for any purpose,
 *	including commercial applications, and to alter it and redistribute it
 *	freely, subject to the following restrictions:
 *
 *	o  The origin of this software must not be misrepresented; you must not
 *	   claim that you wrote the original software. If you use this software
 *	   in a product, an acknowledgment in the product documentation would be
 *	   appreciated but is not required.
 *	o  Altered source versions must be plainly marked as such, and must not
 *	   be misrepresented as being the original software.
 *	o  This notice may not be removed or altered from any source
 *	   distribution.
 */

bool isValidDchar(dchar c)
{
	/* Note: FFFE and FFFF are specifically permitted by the
	 * Unicode standard for application internal use, but are not
	 * allowed for interchange.
	 * (thanks to Arcane Jill)
	 */

	return c < 0xD800 ||
	(c > 0xDFFF && c <= 0x10FFFF /*&& c != 0xFFFE && c != 0xFFFF*/);
}

/***************
 * Decodes and returns character starting at s[idx]. idx is advanced past the
 * decoded character. If the character is not well formed, a UtfException is
 * thrown and idx remains unchanged.
 */

dchar decode(in char[] s, inout size_t idx)
	{
	size_t len = s.length;
	dchar V;
	size_t i = idx;
	char u = s[i];

	if (u & 0x80)
	{	uint n;
		char u2;

		/* The following encodings are valid, except for the 5 and 6 byte
		 * combinations:
		 *	0xxxxxxx
		 *	110xxxxx 10xxxxxx
		 *	1110xxxx 10xxxxxx 10xxxxxx
		 *	11110xxx 10xxxxxx 10xxxxxx 10xxxxxx
		 *	111110xx 10xxxxxx 10xxxxxx 10xxxxxx 10xxxxxx
		 *	1111110x 10xxxxxx 10xxxxxx 10xxxxxx 10xxxxxx 10xxxxxx
		 */
		for (n = 1; ; n++)
		{
		if (n > 4)
			goto Lerr;		// only do the first 4 of 6 encodings
		if (((u << n) & 0x80) == 0)
		{
			if (n == 1)
			goto Lerr;
			break;
		}
		}

		// Pick off (7 - n) significant bits of B from first byte of octet
		V = cast(dchar)(u & ((1 << (7 - n)) - 1));

		if (i + (n - 1) >= len)
		goto Lerr;			// off end of string

		/* The following combinations are overlong, and illegal:
		 *	1100000x (10xxxxxx)
		 *	11100000 100xxxxx (10xxxxxx)
		 *	11110000 1000xxxx (10xxxxxx 10xxxxxx)
		 *	11111000 10000xxx (10xxxxxx 10xxxxxx 10xxxxxx)
		 *	11111100 100000xx (10xxxxxx 10xxxxxx 10xxxxxx 10xxxxxx)
		 */
		u2 = s[i + 1];
		if ((u & 0xFE) == 0xC0 ||
		(u == 0xE0 && (u2 & 0xE0) == 0x80) ||
		(u == 0xF0 && (u2 & 0xF0) == 0x80) ||
		(u == 0xF8 && (u2 & 0xF8) == 0x80) ||
		(u == 0xFC && (u2 & 0xFC) == 0x80))
		goto Lerr;			// overlong combination

		for (uint j = 1; j != n; j++)
		{
		u = s[i + j];
		if ((u & 0xC0) != 0x80)
			goto Lerr;			// trailing bytes are 10xxxxxx
		V = (V << 6) | (u & 0x3F);
		}
		if (!isValidDchar(V))
		goto Lerr;
		i += n;
	}
	else
	{
		V = cast(dchar) u;
		i++;
	}

	idx = i;
	return V;

	  Lerr:
	throw new Exception("4invalid UTF-8 sequence");
	}
}
else
{
	import std.utf;
}

// lexer code
// generated code start
// ((?\*)|(?\()|(?\))|(?\.)|(?\[)|(?\])|(?\.\.)|(?#(e[abcd]x|e[ds]i|e[bs]p|eip|efl))|(?#([abcd]x|[ds]i|[bs]p|(cdefgs)s))|(?#[abcd][hl])|(?#st[0-7])|(?#mm[0-7])|(?#xmm[0-7])|(?cast)|(?!)|(?,)|(?"(([^"\\]*(\\(['"\?\\abfnrtv]|(x[0-9a-fA-F]{2})|(u[0-9a-fA-F]{4})|(U[0-9a-fA-F]{8})))?)*)")|(?'(([^'\\]|(\\(['"\?\\abfnrtv]|(x[0-9a-fA-F]{2})|(u[0-9a-fA-F]{4})|(U[0-9a-fA-F]{8})))))')|(?[a-zA-Z_][_a-zA-Z0-9]*)|(?0[xX][0-9a-fA-F_]+)|(?0[bB][01_]+)|(?0[0-7_]+)|(?0|([1-9][0-9_]*))|(?L)|(?u)|(?U)|(?[uU])|(?\-)).*?
bool mainLexer(char[] input, out uint token, out char[] match)
{
	uint s = 0;
	static int r56=-1, r57=-1, r58=-1, r59=-1, r60=-1, r61=-1, r62=-1, r63=-1, r64=-1, r65=-1,
		r66=-1, r67=-1, r68=-1, r69=-1, r70=-1, r71=-1, r72=-1, r73=-1, r74=-1, r75=-1,
		r76=-1, r77=-1, r78=-1, r79=-1, r80=-1, r81=-1, r82=-1, r83=-1, r84=-1, r85=-1,
		r86=-1;

	for ( size_t p, next_p; p < input.length; )
	{
		dchar c = cast(dchar)input[p];
		if ( c & 0x80 )
			decode(input, next_p);
		else
			next_p = p+1;
		switch ( s )
		{
			case 0:
				if ( c == 0x22 ) {
					s = 2;
					p = next_p;
				}
				else if ( c == 0x2e ) {
					s = 10;
					p = next_p;
					r62 = p;
				}
				else if ( c == 0x27 ) {
					s = 4;
					p = next_p;
				}
				else if ( c == 0x30 ) {
					s = 11;
					p = next_p;
					r63 = p;
				}
				else if ( c == 0x29 ) {
					s = 6;
					p = next_p;
					r58 = p;
				}
				else if ( c >= 0x31 && c <= 0x39 ) {
					s = 12;
					p = next_p;
					r63 = p;
				}
				else if ( c == 0x2c ) {
					s = 8;
					p = next_p;
					r60 = p;
				}
				else if ( c == 0x4c ) {
					s = 13;
					p = next_p;
					r64 = p;
				}
				else if ( c == 0x21 ) {
					s = 1;
					p = next_p;
					r56 = p;
				}
				else if ( c == 0x55 ) {
					s = 13;
					p = next_p;
					r64 = p;
				}
				else if ( c == 0x28 ) {
					s = 5;
					p = next_p;
					r57 = p;
				}
				else if ( c == 0x5b ) {
					s = 16;
					p = next_p;
					r65 = p;
				}
				else if ( c == 0x75 ) {
					s = 13;
					p = next_p;
					r64 = p;
				}
				else if ( c == 0x63 ) {
					s = 18;
					p = next_p;
					r64 = p;
				}
				else if ( c == 0x5d ) {
					s = 17;
					p = next_p;
					r66 = p;
				}
				else if ( c == 0x23 ) {
					s = 3;
					p = next_p;
				}
				else if ( c == 0x2d ) {
					s = 9;
					p = next_p;
					r61 = p;
				}
				else if ( c == 0x2a ) {
					s = 7;
					p = next_p;
					r59 = p;
				}
				else if ( c >= 0x41 && c <= 0x4b || c >= 0x4d && c <= 0x54 || c >= 0x56 && c <= 0x5a || c == 0x5f || c >= 0x61 && c <= 0x62 || c >= 0x64 && c <= 0x74 || c >= 0x76 && c <= 0x7a ) {
					s = 13;
					p = next_p;
					r64 = p;
				}
				else
					return false;
				break;
			case 1:
				goto finish1;
			case 2:
				if ( c == 0x5c ) {
					s = 109;
					p = next_p;
				}
				else if ( c == 0x22 ) {
					s = 108;
					p = next_p;
					r67 = p;
				}
				else if ( c >= 0x0 && c <= 0x10ffff ) {
					s = 2;
					p = next_p;
				}
				else
					return false;
				break;
			case 3:
				if ( c == 0x78 ) {
					s = 79;
					p = next_p;
				}
				else if ( c == 0x62 ) {
					s = 72;
					p = next_p;
				}
				else if ( c == 0x65 ) {
					s = 76;
					p = next_p;
				}
				else if ( c == 0x73 ) {
					s = 78;
					p = next_p;
				}
				else if ( c == 0x6d ) {
					s = 77;
					p = next_p;
				}
				else if ( c == 0x61 ) {
					s = 72;
					p = next_p;
				}
				else if ( c == 0x64 ) {
					s = 72;
					p = next_p;
				}
				else if ( c == 0x63 ) {
					s = 74;
					p = next_p;
				}
				else
					return false;
				break;
			case 4:
				if ( c == 0x5c ) {
					s = 51;
					p = next_p;
				}
				else if ( c >= 0x0 && c <= 0x26 || c >= 0x28 && c <= 0x10ffff ) {
					s = 50;
					p = next_p;
				}
				else
					return false;
				break;
			case 5:
				goto finish5;
			case 6:
				goto finish6;
			case 7:
				goto finish7;
			case 8:
				goto finish8;
			case 9:
				goto finish9;
			case 10:
				if ( c == 0x2e ) {
					s = 43;
					p = next_p;
					r68 = p;
				}
				else if ( c >= 0x9 && c <= 0x13 || c >= 0x20 && c <= 0x7e || c >= 0xa0 && c <= 0x24f || c >= 0x20a3 && c <= 0x20b5 ) {
					s = 42;
					p = next_p;
				}
				else
					goto finish10;
				break;
			case 11:
				if ( c == 0x58 || c == 0x78 ) {
					s = 33;
					p = next_p;
				}
				else if ( c == 0x42 || c == 0x62 ) {
					s = 32;
					p = next_p;
				}
				else if ( c >= 0x30 && c <= 0x37 || c == 0x5f ) {
					s = 31;
					p = next_p;
					r69 = p;
				}
				else if ( c >= 0x9 && c <= 0x13 || c >= 0x20 && c <= 0x7e || c >= 0xa0 && c <= 0x24f || c >= 0x20a3 && c <= 0x20b5 ) {
					s = 29;
					p = next_p;
				}
				else
					goto finish11;
				break;
			case 12:
				if ( c >= 0x30 && c <= 0x39 || c == 0x5f ) {
					s = 30;
					p = next_p;
					r70 = p;
				}
				else if ( c >= 0x9 && c <= 0x13 || c >= 0x20 && c <= 0x7e || c >= 0xa0 && c <= 0x24f || c >= 0x20a3 && c <= 0x20b5 ) {
					s = 29;
					p = next_p;
				}
				else
					goto finish12;
				break;
			case 13:
				if ( c >= 0x30 && c <= 0x39 || c >= 0x41 && c <= 0x5a || c == 0x5f || c >= 0x61 && c <= 0x7a ) {
					s = 21;
					p = next_p;
					r71 = p;
				}
				else if ( c >= 0x9 && c <= 0x13 || c >= 0x20 && c <= 0x7e || c >= 0xa0 && c <= 0x24f || c >= 0x20a3 && c <= 0x20b5 ) {
					s = 20;
					p = next_p;
				}
				else
					goto finish13;
				break;
			case 14:
				if ( c >= 0x30 && c <= 0x39 || c >= 0x41 && c <= 0x5a || c == 0x5f || c >= 0x61 && c <= 0x7a ) {
					s = 21;
					p = next_p;
					r71 = p;
				}
				else if ( c >= 0x9 && c <= 0x13 || c >= 0x20 && c <= 0x7e || c >= 0xa0 && c <= 0x24f || c >= 0x20a3 && c <= 0x20b5 ) {
					s = 20;
					p = next_p;
				}
				else
					goto finish14;
				break;
			case 15:
				if ( c >= 0x30 && c <= 0x39 || c >= 0x41 && c <= 0x5a || c == 0x5f || c >= 0x61 && c <= 0x7a ) {
					s = 21;
					p = next_p;
					r71 = p;
				}
				else if ( c >= 0x9 && c <= 0x13 || c >= 0x20 && c <= 0x7e || c >= 0xa0 && c <= 0x24f || c >= 0x20a3 && c <= 0x20b5 ) {
					s = 20;
					p = next_p;
				}
				else
					goto finish15;
				break;
			case 16:
				goto finish16;
			case 17:
				goto finish17;
			case 18:
				if ( c == 0x61 ) {
					s = 22;
					p = next_p;
					r71 = p;
				}
				else if ( c >= 0x30 && c <= 0x39 || c >= 0x41 && c <= 0x5a || c == 0x5f || c >= 0x61 && c <= 0x7a ) {
					s = 21;
					p = next_p;
					r71 = p;
				}
				else if ( c >= 0x9 && c <= 0x13 || c >= 0x20 && c <= 0x7e || c >= 0xa0 && c <= 0x24f || c >= 0x20a3 && c <= 0x20b5 ) {
					s = 20;
					p = next_p;
				}
				else
					goto finish18;
				break;
			case 19:
				if ( c >= 0x30 && c <= 0x39 || c >= 0x41 && c <= 0x5a || c == 0x5f || c >= 0x61 && c <= 0x7a ) {
					s = 21;
					p = next_p;
					r71 = p;
				}
				else if ( c >= 0x9 && c <= 0x13 || c >= 0x20 && c <= 0x7e || c >= 0xa0 && c <= 0x24f || c >= 0x20a3 && c <= 0x20b5 ) {
					s = 20;
					p = next_p;
				}
				else
					goto finish19;
				break;
			case 20:
				goto finish20;
			case 21:
				if ( c >= 0x30 && c <= 0x39 || c >= 0x41 && c <= 0x5a || c == 0x5f || c >= 0x61 && c <= 0x7a ) {
					s = 21;
					p = next_p;
					r64 = r71;
					r71 = p;
				}
				else if ( c >= 0x9 && c <= 0x13 || c >= 0x20 && c <= 0x7e || c >= 0xa0 && c <= 0x24f || c >= 0x20a3 && c <= 0x20b5 ) {
					s = 20;
					p = next_p;
					r64 = r71;
				}
				else
					goto finish21;
				break;
			case 22:
				if ( c == 0x73 ) {
					s = 23;
					p = next_p;
					r72 = p;
				}
				else if ( c >= 0x30 && c <= 0x39 || c >= 0x41 && c <= 0x5a || c == 0x5f || c >= 0x61 && c <= 0x7a ) {
					s = 21;
					p = next_p;
					r64 = r71;
					r71 = p;
				}
				else if ( c >= 0x9 && c <= 0x13 || c >= 0x20 && c <= 0x7e || c >= 0xa0 && c <= 0x24f || c >= 0x20a3 && c <= 0x20b5 ) {
					s = 20;
					p = next_p;
					r64 = r71;
				}
				else
					goto finish22;
				break;
			case 23:
				if ( c == 0x74 ) {
					s = 24;
					p = next_p;
					r73 = p;
				}
				else if ( c >= 0x30 && c <= 0x39 || c >= 0x41 && c <= 0x5a || c == 0x5f || c >= 0x61 && c <= 0x7a ) {
					s = 21;
					p = next_p;
					r64 = r72;
					r71 = p;
				}
				else if ( c >= 0x9 && c <= 0x13 || c >= 0x20 && c <= 0x7e || c >= 0xa0 && c <= 0x24f || c >= 0x20a3 && c <= 0x20b5 ) {
					s = 20;
					p = next_p;
					r64 = r72;
				}
				else
					goto finish23;
				break;
			case 24:
				if ( c >= 0x30 && c <= 0x39 || c >= 0x41 && c <= 0x5a || c == 0x5f || c >= 0x61 && c <= 0x7a ) {
					s = 26;
					p = next_p;
					r74 = p;
				}
				else if ( c >= 0x9 && c <= 0x13 || c >= 0x20 && c <= 0x7e || c >= 0xa0 && c <= 0x24f || c >= 0x20a3 && c <= 0x20b5 ) {
					s = 25;
					p = next_p;
				}
				else
					goto finish24;
				break;
			case 25:
				goto finish25;
			case 26:
				if ( c >= 0x30 && c <= 0x39 || c >= 0x41 && c <= 0x5a || c == 0x5f || c >= 0x61 && c <= 0x7a ) {
					s = 21;
					p = next_p;
					r64 = r74;
					r71 = p;
				}
				else if ( c >= 0x9 && c <= 0x13 || c >= 0x20 && c <= 0x7e || c >= 0xa0 && c <= 0x24f || c >= 0x20a3 && c <= 0x20b5 ) {
					s = 20;
					p = next_p;
					r64 = r74;
				}
				else
					goto finish26;
				break;
			case 27:
				if ( c >= 0x9 && c <= 0x13 || c >= 0x20 && c <= 0x7e || c >= 0xa0 && c <= 0x24f || c >= 0x20a3 && c <= 0x20b5 ) {
					s = 17;
					p = next_p;
				}
				else
					goto finish27;
				break;
			case 28:
				if ( c >= 0x9 && c <= 0x13 || c >= 0x20 && c <= 0x7e || c >= 0xa0 && c <= 0x24f || c >= 0x20a3 && c <= 0x20b5 ) {
					s = 16;
					p = next_p;
				}
				else
					goto finish28;
				break;
			case 29:
				goto finish29;
			case 30:
				if ( c >= 0x30 && c <= 0x39 || c == 0x5f ) {
					s = 30;
					p = next_p;
					r63 = r70;
					r70 = p;
				}
				else if ( c >= 0x9 && c <= 0x13 || c >= 0x20 && c <= 0x7e || c >= 0xa0 && c <= 0x24f || c >= 0x20a3 && c <= 0x20b5 ) {
					s = 29;
					p = next_p;
					r63 = r70;
				}
				else
					goto finish30;
				break;
			case 31:
				if ( c >= 0x30 && c <= 0x37 || c == 0x5f ) {
					s = 41;
					p = next_p;
					r75 = p;
				}
				else if ( c >= 0x9 && c <= 0x13 || c >= 0x20 && c <= 0x7e || c >= 0xa0 && c <= 0x24f || c >= 0x20a3 && c <= 0x20b5 ) {
					s = 40;
					p = next_p;
				}
				else
					goto finish31;
				break;
			case 32:
				if ( c >= 0x30 && c <= 0x31 || c == 0x5f ) {
					s = 37;
					p = next_p;
					r76 = p;
				}
				else if ( c >= 0x9 && c <= 0x13 || c >= 0x20 && c <= 0x7e || c >= 0xa0 && c <= 0x24f || c >= 0x20a3 && c <= 0x20b5 ) {
					s = 29;
					p = next_p;
				}
				else
					goto finish32;
				break;
			case 33:
				if ( c >= 0x30 && c <= 0x39 || c >= 0x41 && c <= 0x46 || c == 0x5f || c >= 0x61 && c <= 0x66 ) {
					s = 34;
					p = next_p;
					r77 = p;
				}
				else if ( c >= 0x9 && c <= 0x13 || c >= 0x20 && c <= 0x7e || c >= 0xa0 && c <= 0x24f || c >= 0x20a3 && c <= 0x20b5 ) {
					s = 29;
					p = next_p;
				}
				else
					goto finish33;
				break;
			case 34:
				if ( c >= 0x30 && c <= 0x39 || c >= 0x41 && c <= 0x46 || c == 0x5f || c >= 0x61 && c <= 0x66 ) {
					s = 36;
					p = next_p;
					r78 = p;
				}
				else if ( c >= 0x9 && c <= 0x13 || c >= 0x20 && c <= 0x7e || c >= 0xa0 && c <= 0x24f || c >= 0x20a3 && c <= 0x20b5 ) {
					s = 35;
					p = next_p;
				}
				else
					goto finish34;
				break;
			case 35:
				goto finish35;
			case 36:
				if ( c >= 0x30 && c <= 0x39 || c >= 0x41 && c <= 0x46 || c == 0x5f || c >= 0x61 && c <= 0x66 ) {
					s = 36;
					p = next_p;
					r77 = r78;
					r78 = p;
				}
				else if ( c >= 0x9 && c <= 0x13 || c >= 0x20 && c <= 0x7e || c >= 0xa0 && c <= 0x24f || c >= 0x20a3 && c <= 0x20b5 ) {
					s = 35;
					p = next_p;
					r77 = r78;
				}
				else
					goto finish36;
				break;
			case 37:
				if ( c >= 0x30 && c <= 0x31 || c == 0x5f ) {
					s = 39;
					p = next_p;
					r79 = p;
				}
				else if ( c >= 0x9 && c <= 0x13 || c >= 0x20 && c <= 0x7e || c >= 0xa0 && c <= 0x24f || c >= 0x20a3 && c <= 0x20b5 ) {
					s = 38;
					p = next_p;
				}
				else
					goto finish37;
				break;
			case 38:
				goto finish38;
			case 39:
				if ( c >= 0x30 && c <= 0x31 || c == 0x5f ) {
					s = 39;
					p = next_p;
					r76 = r79;
					r79 = p;
				}
				else if ( c >= 0x9 && c <= 0x13 || c >= 0x20 && c <= 0x7e || c >= 0xa0 && c <= 0x24f || c >= 0x20a3 && c <= 0x20b5 ) {
					s = 38;
					p = next_p;
					r76 = r79;
				}
				else
					goto finish39;
				break;
			case 40:
				goto finish40;
			case 41:
				if ( c >= 0x30 && c <= 0x37 || c == 0x5f ) {
					s = 41;
					p = next_p;
					r69 = r75;
					r75 = p;
				}
				else if ( c >= 0x9 && c <= 0x13 || c >= 0x20 && c <= 0x7e || c >= 0xa0 && c <= 0x24f || c >= 0x20a3 && c <= 0x20b5 ) {
					s = 40;
					p = next_p;
					r69 = r75;
				}
				else
					goto finish41;
				break;
			case 42:
				goto finish42;
			case 43:
				goto finish43;
			case 44:
				if ( c >= 0x9 && c <= 0x13 || c >= 0x20 && c <= 0x7e || c >= 0xa0 && c <= 0x24f || c >= 0x20a3 && c <= 0x20b5 ) {
					s = 43;
					p = next_p;
				}
				else
					goto finish44;
				break;
			case 45:
				if ( c >= 0x9 && c <= 0x13 || c >= 0x20 && c <= 0x7e || c >= 0xa0 && c <= 0x24f || c >= 0x20a3 && c <= 0x20b5 ) {
					s = 9;
					p = next_p;
				}
				else
					goto finish45;
				break;
			case 46:
				if ( c >= 0x9 && c <= 0x13 || c >= 0x20 && c <= 0x7e || c >= 0xa0 && c <= 0x24f || c >= 0x20a3 && c <= 0x20b5 ) {
					s = 8;
					p = next_p;
				}
				else
					goto finish46;
				break;
			case 47:
				if ( c >= 0x9 && c <= 0x13 || c >= 0x20 && c <= 0x7e || c >= 0xa0 && c <= 0x24f || c >= 0x20a3 && c <= 0x20b5 ) {
					s = 7;
					p = next_p;
				}
				else
					goto finish47;
				break;
			case 48:
				if ( c >= 0x9 && c <= 0x13 || c >= 0x20 && c <= 0x7e || c >= 0xa0 && c <= 0x24f || c >= 0x20a3 && c <= 0x20b5 ) {
					s = 6;
					p = next_p;
				}
				else
					goto finish48;
				break;
			case 49:
				if ( c >= 0x9 && c <= 0x13 || c >= 0x20 && c <= 0x7e || c >= 0xa0 && c <= 0x24f || c >= 0x20a3 && c <= 0x20b5 ) {
					s = 5;
					p = next_p;
				}
				else
					goto finish49;
				break;
			case 50:
				if ( c == 0x27 ) {
					s = 58;
					p = next_p;
					r80 = p;
				}
				else
					return false;
				break;
			case 51:
				if ( c == 0x78 ) {
					s = 55;
					p = next_p;
				}
				else if ( c == 0x75 ) {
					s = 54;
					p = next_p;
				}
				else if ( c == 0x55 ) {
					s = 53;
					p = next_p;
				}
				else if ( c == 0x22 || c == 0x27 || c == 0x3f || c == 0x5c || c >= 0x61 && c <= 0x62 || c == 0x66 || c == 0x6e || c == 0x72 || c == 0x74 || c == 0x76 ) {
					s = 50;
					p = next_p;
				}
				else
					return false;
				break;
			case 52:
				if ( c == 0x27 ) {
					s = 58;
					p = next_p;
					r80 = p;
				}
				else
					return false;
				break;
			case 53:
				if ( c >= 0x30 && c <= 0x39 || c >= 0x41 && c <= 0x46 || c >= 0x61 && c <= 0x66 ) {
					s = 64;
					p = next_p;
				}
				else
					return false;
				break;
			case 54:
				if ( c >= 0x30 && c <= 0x39 || c >= 0x41 && c <= 0x46 || c >= 0x61 && c <= 0x66 ) {
					s = 60;
					p = next_p;
				}
				else
					return false;
				break;
			case 55:
				if ( c >= 0x30 && c <= 0x39 || c >= 0x41 && c <= 0x46 || c >= 0x61 && c <= 0x66 ) {
					s = 56;
					p = next_p;
				}
				else
					return false;
				break;
			case 56:
				if ( c >= 0x30 && c <= 0x39 || c >= 0x41 && c <= 0x46 || c >= 0x61 && c <= 0x66 ) {
					s = 50;
					p = next_p;
				}
				else
					return false;
				break;
			case 57:
				if ( c == 0x27 ) {
					s = 58;
					p = next_p;
					r80 = p;
				}
				else
					return false;
				break;
			case 58:
				goto finish58;
			case 59:
				if ( c >= 0x9 && c <= 0x13 || c >= 0x20 && c <= 0x7e || c >= 0xa0 && c <= 0x24f || c >= 0x20a3 && c <= 0x20b5 ) {
					s = 58;
					p = next_p;
				}
				else
					goto finish59;
				break;
			case 60:
				if ( c >= 0x30 && c <= 0x39 || c >= 0x41 && c <= 0x46 || c >= 0x61 && c <= 0x66 ) {
					s = 55;
					p = next_p;
				}
				else
					return false;
				break;
			case 61:
				if ( c >= 0x30 && c <= 0x39 || c >= 0x41 && c <= 0x46 || c >= 0x61 && c <= 0x66 ) {
					s = 56;
					p = next_p;
				}
				else
					return false;
				break;
			case 62:
				if ( c >= 0x30 && c <= 0x39 || c >= 0x41 && c <= 0x46 || c >= 0x61 && c <= 0x66 ) {
					s = 50;
					p = next_p;
				}
				else
					return false;
				break;
			case 63:
				if ( c == 0x27 ) {
					s = 58;
					p = next_p;
					r80 = p;
				}
				else
					return false;
				break;
			case 64:
				if ( c >= 0x30 && c <= 0x39 || c >= 0x41 && c <= 0x46 || c >= 0x61 && c <= 0x66 ) {
					s = 65;
					p = next_p;
				}
				else
					return false;
				break;
			case 65:
				if ( c >= 0x30 && c <= 0x39 || c >= 0x41 && c <= 0x46 || c >= 0x61 && c <= 0x66 ) {
					s = 66;
					p = next_p;
				}
				else
					return false;
				break;
			case 66:
				if ( c >= 0x30 && c <= 0x39 || c >= 0x41 && c <= 0x46 || c >= 0x61 && c <= 0x66 ) {
					s = 54;
					p = next_p;
				}
				else
					return false;
				break;
			case 67:
				if ( c >= 0x30 && c <= 0x39 || c >= 0x41 && c <= 0x46 || c >= 0x61 && c <= 0x66 ) {
					s = 60;
					p = next_p;
				}
				else
					return false;
				break;
			case 68:
				if ( c >= 0x30 && c <= 0x39 || c >= 0x41 && c <= 0x46 || c >= 0x61 && c <= 0x66 ) {
					s = 55;
					p = next_p;
				}
				else
					return false;
				break;
			case 69:
				if ( c >= 0x30 && c <= 0x39 || c >= 0x41 && c <= 0x46 || c >= 0x61 && c <= 0x66 ) {
					s = 56;
					p = next_p;
				}
				else
					return false;
				break;
			case 70:
				if ( c >= 0x30 && c <= 0x39 || c >= 0x41 && c <= 0x46 || c >= 0x61 && c <= 0x66 ) {
					s = 50;
					p = next_p;
				}
				else
					return false;
				break;
			case 71:
				if ( c == 0x27 ) {
					s = 58;
					p = next_p;
					r80 = p;
				}
				else
					return false;
				break;
			case 72:
				if ( c == 0x78 ) {
					s = 84;
					p = next_p;
					r82 = p;
				}
				else if ( c == 0x68 || c == 0x6c ) {
					s = 100;
					p = next_p;
					r81 = p;
				}
				else
					return false;
				break;
			case 73:
				if ( c == 0x70 || c == 0x78 ) {
					s = 84;
					p = next_p;
					r82 = p;
				}
				else if ( c == 0x68 || c == 0x6c ) {
					s = 100;
					p = next_p;
					r81 = p;
				}
				else
					return false;
				break;
			case 74:
				if ( c == 0x78 ) {
					s = 84;
					p = next_p;
					r82 = p;
				}
				else if ( c == 0x64 ) {
					s = 102;
					p = next_p;
				}
				else if ( c == 0x68 || c == 0x6c ) {
					s = 100;
					p = next_p;
					r81 = p;
				}
				else
					return false;
				break;
			case 75:
				if ( c == 0x69 || c == 0x78 ) {
					s = 84;
					p = next_p;
					r82 = p;
				}
				else if ( c == 0x68 || c == 0x6c ) {
					s = 100;
					p = next_p;
					r81 = p;
				}
				else
					return false;
				break;
			case 76:
				if ( c == 0x73 ) {
					s = 93;
					p = next_p;
				}
				else if ( c == 0x69 ) {
					s = 93;
					p = next_p;
				}
				else if ( c == 0x66 ) {
					s = 95;
					p = next_p;
				}
				else if ( c == 0x64 ) {
					s = 92;
					p = next_p;
				}
				else if ( c == 0x62 ) {
					s = 92;
					p = next_p;
				}
				else if ( c == 0x61 || c == 0x63 ) {
					s = 92;
					p = next_p;
				}
				else
					return false;
				break;
			case 77:
				if ( c == 0x6d ) {
					s = 89;
					p = next_p;
				}
				else
					return false;
				break;
			case 78:
				if ( c == 0x74 ) {
					s = 85;
					p = next_p;
				}
				else if ( c == 0x69 || c == 0x70 ) {
					s = 84;
					p = next_p;
					r82 = p;
				}
				else
					return false;
				break;
			case 79:
				if ( c == 0x6d ) {
					s = 80;
					p = next_p;
				}
				else
					return false;
				break;
			case 80:
				if ( c == 0x6d ) {
					s = 81;
					p = next_p;
				}
				else
					return false;
				break;
			case 81:
				if ( c >= 0x30 && c <= 0x37 ) {
					s = 82;
					p = next_p;
					r83 = p;
				}
				else
					return false;
				break;
			case 82:
				goto finish82;
			case 83:
				if ( c >= 0x9 && c <= 0x13 || c >= 0x20 && c <= 0x7e || c >= 0xa0 && c <= 0x24f || c >= 0x20a3 && c <= 0x20b5 ) {
					s = 82;
					p = next_p;
				}
				else
					goto finish83;
				break;
			case 84:
				goto finish84;
			case 85:
				if ( c >= 0x30 && c <= 0x37 ) {
					s = 86;
					p = next_p;
					r84 = p;
				}
				else
					return false;
				break;
			case 86:
				goto finish86;
			case 87:
				if ( c >= 0x9 && c <= 0x13 || c >= 0x20 && c <= 0x7e || c >= 0xa0 && c <= 0x24f || c >= 0x20a3 && c <= 0x20b5 ) {
					s = 86;
					p = next_p;
				}
				else
					goto finish87;
				break;
			case 88:
				if ( c >= 0x9 && c <= 0x13 || c >= 0x20 && c <= 0x7e || c >= 0xa0 && c <= 0x24f || c >= 0x20a3 && c <= 0x20b5 ) {
					s = 84;
					p = next_p;
				}
				else
					goto finish88;
				break;
			case 89:
				if ( c >= 0x30 && c <= 0x37 ) {
					s = 90;
					p = next_p;
					r85 = p;
				}
				else
					return false;
				break;
			case 90:
				goto finish90;
			case 91:
				if ( c >= 0x9 && c <= 0x13 || c >= 0x20 && c <= 0x7e || c >= 0xa0 && c <= 0x24f || c >= 0x20a3 && c <= 0x20b5 ) {
					s = 90;
					p = next_p;
				}
				else
					goto finish91;
				break;
			case 92:
				if ( c == 0x78 ) {
					s = 98;
					p = next_p;
					r86 = p;
				}
				else
					return false;
				break;
			case 93:
				if ( c == 0x70 || c == 0x78 ) {
					s = 98;
					p = next_p;
					r86 = p;
				}
				else
					return false;
				break;
			case 94:
				if ( c == 0x69 || c == 0x78 ) {
					s = 98;
					p = next_p;
					r86 = p;
				}
				else
					return false;
				break;
			case 95:
				if ( c == 0x6c ) {
					s = 98;
					p = next_p;
					r86 = p;
				}
				else
					return false;
				break;
			case 96:
				if ( c == 0x70 ) {
					s = 98;
					p = next_p;
					r86 = p;
				}
				else
					return false;
				break;
			case 97:
				if ( c == 0x69 || c == 0x70 ) {
					s = 98;
					p = next_p;
					r86 = p;
				}
				else
					return false;
				break;
			case 98:
				goto finish98;
			case 99:
				if ( c >= 0x9 && c <= 0x13 || c >= 0x20 && c <= 0x7e || c >= 0xa0 && c <= 0x24f || c >= 0x20a3 && c <= 0x20b5 ) {
					s = 98;
					p = next_p;
				}
				else
					goto finish99;
				break;
			case 100:
				goto finish100;
			case 101:
				if ( c >= 0x9 && c <= 0x13 || c >= 0x20 && c <= 0x7e || c >= 0xa0 && c <= 0x24f || c >= 0x20a3 && c <= 0x20b5 ) {
					s = 100;
					p = next_p;
				}
				else
					goto finish101;
				break;
			case 102:
				if ( c == 0x65 ) {
					s = 103;
					p = next_p;
				}
				else
					return false;
				break;
			case 103:
				if ( c == 0x66 ) {
					s = 104;
					p = next_p;
				}
				else
					return false;
				break;
			case 104:
				if ( c == 0x67 ) {
					s = 105;
					p = next_p;
				}
				else
					return false;
				break;
			case 105:
				if ( c == 0x73 ) {
					s = 106;
					p = next_p;
				}
				else
					return false;
				break;
			case 106:
				if ( c == 0x73 ) {
					s = 84;
					p = next_p;
					r82 = p;
				}
				else
					return false;
				break;
			case 107:
				if ( c == 0x5c ) {
					s = 109;
					p = next_p;
				}
				else if ( c == 0x22 ) {
					s = 108;
					p = next_p;
					r67 = p;
				}
				else if ( c >= 0x0 && c <= 0x10ffff ) {
					s = 2;
					p = next_p;
				}
				else
					return false;
				break;
			case 108:
				goto finish108;
			case 109:
				if ( c == 0x78 ) {
					s = 113;
					p = next_p;
				}
				else if ( c == 0x75 ) {
					s = 112;
					p = next_p;
				}
				else if ( c == 0x55 ) {
					s = 111;
					p = next_p;
				}
				else if ( c == 0x22 || c == 0x27 || c == 0x3f || c == 0x5c || c >= 0x61 && c <= 0x62 || c == 0x66 || c == 0x6e || c == 0x72 || c == 0x74 || c == 0x76 ) {
					s = 2;
					p = next_p;
				}
				else
					return false;
				break;
			case 110:
				if ( c == 0x5c ) {
					s = 109;
					p = next_p;
				}
				else if ( c == 0x22 ) {
					s = 108;
					p = next_p;
					r67 = p;
				}
				else if ( c >= 0x0 && c <= 0x10ffff ) {
					s = 2;
					p = next_p;
				}
				else
					return false;
				break;
			case 111:
				if ( c >= 0x30 && c <= 0x39 || c >= 0x41 && c <= 0x46 || c >= 0x61 && c <= 0x66 ) {
					s = 120;
					p = next_p;
				}
				else
					return false;
				break;
			case 112:
				if ( c >= 0x30 && c <= 0x39 || c >= 0x41 && c <= 0x46 || c >= 0x61 && c <= 0x66 ) {
					s = 116;
					p = next_p;
				}
				else
					return false;
				break;
			case 113:
				if ( c >= 0x30 && c <= 0x39 || c >= 0x41 && c <= 0x46 || c >= 0x61 && c <= 0x66 ) {
					s = 114;
					p = next_p;
				}
				else
					return false;
				break;
			case 114:
				if ( c >= 0x30 && c <= 0x39 || c >= 0x41 && c <= 0x46 || c >= 0x61 && c <= 0x66 ) {
					s = 2;
					p = next_p;
				}
				else
					return false;
				break;
			case 115:
				if ( c == 0x5c ) {
					s = 109;
					p = next_p;
				}
				else if ( c == 0x22 ) {
					s = 108;
					p = next_p;
					r67 = p;
				}
				else if ( c >= 0x0 && c <= 0x10ffff ) {
					s = 2;
					p = next_p;
				}
				else
					return false;
				break;
			case 116:
				if ( c >= 0x30 && c <= 0x39 || c >= 0x41 && c <= 0x46 || c >= 0x61 && c <= 0x66 ) {
					s = 113;
					p = next_p;
				}
				else
					return false;
				break;
			case 117:
				if ( c >= 0x30 && c <= 0x39 || c >= 0x41 && c <= 0x46 || c >= 0x61 && c <= 0x66 ) {
					s = 114;
					p = next_p;
				}
				else
					return false;
				break;
			case 118:
				if ( c >= 0x30 && c <= 0x39 || c >= 0x41 && c <= 0x46 || c >= 0x61 && c <= 0x66 ) {
					s = 2;
					p = next_p;
				}
				else
					return false;
				break;
			case 119:
				if ( c == 0x5c ) {
					s = 109;
					p = next_p;
				}
				else if ( c == 0x22 ) {
					s = 108;
					p = next_p;
					r67 = p;
				}
				else if ( c >= 0x0 && c <= 0x10ffff ) {
					s = 2;
					p = next_p;
				}
				else
					return false;
				break;
			case 120:
				if ( c >= 0x30 && c <= 0x39 || c >= 0x41 && c <= 0x46 || c >= 0x61 && c <= 0x66 ) {
					s = 121;
					p = next_p;
				}
				else
					return false;
				break;
			case 121:
				if ( c >= 0x30 && c <= 0x39 || c >= 0x41 && c <= 0x46 || c >= 0x61 && c <= 0x66 ) {
					s = 122;
					p = next_p;
				}
				else
					return false;
				break;
			case 122:
				if ( c >= 0x30 && c <= 0x39 || c >= 0x41 && c <= 0x46 || c >= 0x61 && c <= 0x66 ) {
					s = 112;
					p = next_p;
				}
				else
					return false;
				break;
			case 123:
				if ( c >= 0x30 && c <= 0x39 || c >= 0x41 && c <= 0x46 || c >= 0x61 && c <= 0x66 ) {
					s = 116;
					p = next_p;
				}
				else
					return false;
				break;
			case 124:
				if ( c >= 0x30 && c <= 0x39 || c >= 0x41 && c <= 0x46 || c >= 0x61 && c <= 0x66 ) {
					s = 113;
					p = next_p;
				}
				else
					return false;
				break;
			case 125:
				if ( c >= 0x30 && c <= 0x39 || c >= 0x41 && c <= 0x46 || c >= 0x61 && c <= 0x66 ) {
					s = 114;
					p = next_p;
				}
				else
					return false;
				break;
			case 126:
				if ( c >= 0x30 && c <= 0x39 || c >= 0x41 && c <= 0x46 || c >= 0x61 && c <= 0x66 ) {
					s = 2;
					p = next_p;
				}
				else
					return false;
				break;
			case 127:
				if ( c == 0x5c ) {
					s = 109;
					p = next_p;
				}
				else if ( c == 0x22 ) {
					s = 108;
					p = next_p;
					r67 = p;
				}
				else if ( c >= 0x0 && c <= 0x10ffff ) {
					s = 2;
					p = next_p;
				}
				else
					return false;
				break;
			case 128:
				if ( c >= 0x9 && c <= 0x13 || c >= 0x20 && c <= 0x7e || c >= 0xa0 && c <= 0x24f || c >= 0x20a3 && c <= 0x20b5 ) {
					s = 108;
					p = next_p;
				}
				else
					goto finish128;
				break;
			case 129:
				if ( c >= 0x9 && c <= 0x13 || c >= 0x20 && c <= 0x7e || c >= 0xa0 && c <= 0x24f || c >= 0x20a3 && c <= 0x20b5 ) {
					s = 1;
					p = next_p;
				}
				else
					goto finish129;
				break;
			default:
				assert(0);
		}
	}

	switch ( s )
	{
		case 1: finish1:
		case 129: finish129:
			match = input[0 .. r56];
			token = 14;
			break;
		case 98: finish98:
		case 99: finish99:
			match = input[0 .. r86];
			token = 7;
			break;
		case 100: finish100:
		case 101: finish101:
			match = input[0 .. r81];
			token = 9;
			break;
		case 5: finish5:
		case 49: finish49:
			match = input[0 .. r57];
			token = 1;
			break;
		case 6: finish6:
		case 48: finish48:
			match = input[0 .. r58];
			token = 2;
			break;
		case 7: finish7:
		case 47: finish47:
			match = input[0 .. r59];
			token = 0;
			break;
		case 8: finish8:
		case 46: finish46:
			match = input[0 .. r60];
			token = 15;
			break;
		case 9: finish9:
		case 45: finish45:
			match = input[0 .. r61];
			token = 27;
			break;
		case 10: finish10:
		case 42: finish42:
			match = input[0 .. r62];
			token = 3;
			break;
		case 11: finish11:
		case 12: finish12:
		case 29: finish29:
		case 32: finish32:
		case 33: finish33:
			match = input[0 .. r63];
			token = 22;
			break;
		case 108: finish108:
		case 128: finish128:
			match = input[0 .. r67];
			token = 16;
			break;
		case 13: finish13:
		case 14: finish14:
		case 15: finish15:
		case 18: finish18:
		case 19: finish19:
		case 20: finish20:
			match = input[0 .. r64];
			token = 18;
			break;
		case 16: finish16:
		case 28: finish28:
			match = input[0 .. r65];
			token = 4;
			break;
		case 17: finish17:
		case 27: finish27:
			match = input[0 .. r66];
			token = 5;
			break;
		case 21: finish21:
		case 22: finish22:
			match = input[0 .. r71];
			token = 18;
			break;
		case 23: finish23:
			match = input[0 .. r72];
			token = 18;
			break;
		case 24: finish24:
		case 25: finish25:
			match = input[0 .. r73];
			token = 13;
			break;
		case 26: finish26:
			match = input[0 .. r74];
			token = 18;
			break;
		case 30: finish30:
			match = input[0 .. r70];
			token = 22;
			break;
		case 31: finish31:
		case 40: finish40:
			match = input[0 .. r69];
			token = 21;
			break;
		case 34: finish34:
		case 35: finish35:
			match = input[0 .. r77];
			token = 19;
			break;
		case 36: finish36:
			match = input[0 .. r78];
			token = 19;
			break;
		case 37: finish37:
		case 38: finish38:
			match = input[0 .. r76];
			token = 20;
			break;
		case 39: finish39:
			match = input[0 .. r79];
			token = 20;
			break;
		case 41: finish41:
			match = input[0 .. r75];
			token = 21;
			break;
		case 43: finish43:
		case 44: finish44:
			match = input[0 .. r68];
			token = 6;
			break;
		case 58: finish58:
		case 59: finish59:
			match = input[0 .. r80];
			token = 17;
			break;
		case 82: finish82:
		case 83: finish83:
			match = input[0 .. r83];
			token = 12;
			break;
		case 84: finish84:
		case 88: finish88:
			match = input[0 .. r82];
			token = 8;
			break;
		case 86: finish86:
		case 87: finish87:
			match = input[0 .. r84];
			token = 10;
			break;
		case 90: finish90:
		case 91: finish91:
			match = input[0 .. r85];
			token = 11;
			break;
		default:
			return false;
	}

	return true;
}
// ((?[\t\n\r ]+)).*?
bool wsLexer(char[] input, out uint token, out char[] match)
{
	uint s = 0;
	static int r2=-1, r3=-1;

	for ( size_t p, next_p; p < input.length; )
	{
		dchar c = cast(dchar)input[p];
		if ( c & 0x80 )
			decode(input, next_p);
		else
			next_p = p+1;
		switch ( s )
		{
			case 0:
				if ( c >= 0x9 && c <= 0xa || c == 0xd || c == 0x20 ) {
					s = 1;
					p = next_p;
					r2 = p;
				}
				else
					return false;
				break;
			case 1:
				if ( c >= 0x9 && c <= 0xa || c == 0xd || c == 0x20 ) {
					s = 2;
					p = next_p;
					r3 = p;
				}
				else if ( c >= 0x9 && c <= 0x13 || c >= 0x20 && c <= 0x7e || c >= 0xa0 && c <= 0x24f || c >= 0x20a3 && c <= 0x20b5 ) {
					s = 3;
					p = next_p;
				}
				else
					goto finish1;
				break;
			case 2:
				if ( c >= 0x9 && c <= 0xa || c == 0xd || c == 0x20 ) {
					s = 2;
					p = next_p;
					r2 = r3;
					r3 = p;
				}
				else if ( c >= 0x9 && c <= 0x13 || c >= 0x20 && c <= 0x7e || c >= 0xa0 && c <= 0x24f || c >= 0x20a3 && c <= 0x20b5 ) {
					s = 3;
					p = next_p;
					r2 = r3;
				}
				else
					goto finish2;
				break;
			case 3:
				goto finish3;
			default:
				assert(0);
		}
	}

	switch ( s )
	{
		case 1: finish1:
		case 3: finish3:
			match = input[0 .. r2];
			token = 0;
			break;
		case 2: finish2:
			match = input[0 .. r3];
			token = 0;
			break;
		default:
			return false;
	}

	return true;
}
// generated code end

#line 3074 "src\expression\expression_apd.d"
// Written in the D programming language

/*
 *	This file has been automatically generated by APaGeD v0.5 beta - Attributed Parser Generator for D.
 *
 *	Sections generated from custom input are marked as "generated code" and
 *	are subject to the terms and conditions stated in one of these sections.
 *	The remaining sections are part of the APaGeD package and subject
 *	to the terms and conditions of the corresponding license.
 *
 *	Attributed Parser Generator for D
 *	Copyright (c) 2007-2008 Jascha Wetzel. All rights reserved
 *	License: Artistic License 2.0
 */


version(Tango)
{
	import tango.text.convert.Layout;
	import Int = tango.text.convert.Integer;
	import tango.text.Util;
	import tango.util.log.Trace;

	private static Layout!(char) layout;

	static this()
	{
		layout = new Layout!(char);
	}

	string format(string fmt, ...)
	{
		return layout.convert(_arguments, _argptr, fmt);
	}

	static if ( !is(string) ) {
		private alias char[] string;
	}
}
else
{
	import std.string;
	import std.utf;
	debug import std.stdio;
}



/**************************************************************************************************
	Parser
**************************************************************************************************/

typedef uint Token;
alias Token Symbol;

const Token 	EPSILON 		= 1,
				ALTERN			= 2,
				EOS 			= 3,
				FIRST_TOKEN 	= 4,
				FIRST_NT		= 0x1000;

// generated code start
/*	Attributed Parser Generator for D
 *	Copyright (c) 2007 Jascha Wetzel. All rights reserved
 *	License: Artistic License 2.0, see license.txt
 */

const uint	MAX_INPUT_DUMP = 70,
			LR_STACK_RESERVE = 100,
			NODE_STACK_RESERVE = 20,
			BRANCH_STACK_RESERVE = 100;

/*******************************************************************************
	Stack based on dynamic array
*******************************************************************************/
struct Stack(T)
{
	size_t	_top;
	T[] 	stack;

	void push(T v)
	{
		if ( _top >= stack.length )
			stack.length = stack.length*2+1;
		stack[_top] = v;
		++_top;
	}

	void push(T[] vs)
	{
		size_t end = _top+vs.length;
		if ( end > stack.length )
			stack.length = end*2;
		stack[_top..end] = vs;
		_top = end;
	}
	alias push opCatAssign;

	void pop(size_t num)
	{
		assert(_top>=num, __FILE__~"("~std.string.toString(__LINE__)~")");
		if ( num >= _top )
			_top = 0;
		else
			_top -= num;
	}

	T pop()
	{
		assert(_top>0, __FILE__~"("~std.string.toString(__LINE__)~")");
		return stack[--_top];
	}

	T* popPtr()
	{
		assert(_top>0, __FILE__~"("~std.string.toString(__LINE__)~")");
		return &stack[--_top];
	}

	T top()
	{
		assert(_top>0, __FILE__~"("~std.string.toString(__LINE__)~")");
		return stack[_top-1];
	}

	T* topPtr()
	{
		assert(_top>0, __FILE__~"("~std.string.toString(__LINE__)~")");
		return &stack[_top-1];
	}

	bool empty()
	{
		return _top == 0;
	}

	void clear()
	{
		_top = 0;
	}

	size_t length()
	{
		return _top;
	}

	T[] array()
	{
		return stack[0.._top];
	}

	Stack dup()
	{
		Stack s;
		s._top = _top;
		s.stack = stack.dup;
		return s;
	}

	void free()
	{
		_top = 0;
		delete stack;
	}
}

/**************************************************************************************************
	Information about rules needed for reduction and error handling
**************************************************************************************************/
align(1) struct RuleInfo
{
	bool	ast_node;
	uint	symbol_count,
			nt_count,
			nt_index;
	Symbol[]  symbols;
}

/**************************************************************************************************
	Information about LALR(1) entries needed for debugging
**************************************************************************************************/
align(1) struct EntryInfo
{
	uint	rule_index,
			pos;
}

/**************************************************************************************************
	Exception thrown on parser error
**************************************************************************************************/
class ParserException : Exception
{
	uint	line,
			column;
	string	filename,
			error_message,
			detail;

	this(uint line_, uint column_, string fname, string msg, string dtl="detail")
	{
		version(Tango)
			super(format("{}({}:{}): {}{}", fname, line_, column_, msg, dtl !is null?"\n"~dtl:""));
		else
			super(format("%s(%d:%d): %s%s", fname, line_, column_, msg, dtl !is null?"\n"~dtl:""));
		filename = fname;
		error_message = msg;
		line = line_;
		column = column_;
		detail = dtl;
	}
}

/**************************************************************************************************
	Wraps instantiation of the GLR parser class and the parse call.
**************************************************************************************************/
bool parse(string filename, string input, out SyntaxTree root, bool detailed=false, bool recover=false, uint tab_width=4)
{
	GLRParser	g, w;
	static if ( is(typeof(WhitespaceGrammar) : GLRParser) )
		w = new WhitespaceGrammar;
	g = new MainGrammar(w, tab_width);
	bool succ = g.parse(filename, input, root, detailed, recover);
	return succ;
}

/**************************************************************************************************
	GLR parser
**************************************************************************************************/
abstract class GLRParser
{
	struct LRState
	{
		uint	index,
				line,
				column;
	}

	struct Node
	{
		SyntaxTree	node;
		bool		sync;
	}

	struct LRBranch
	{
		Stack!(LRState) stack;
		Stack!(Node)	node_stack;
		string			input,
						lookahead,
						lookahead_ws;
		uint			line,
						column,
						symbol;
		bool			fatal_errors;
		uint			action;
		version(ProfileConflicts)
			uint			last_conflict;
	}

	string			filename_;
	uint			tab_width_;

	// operational variables
	string				match_,
						match_ws_,
						lookahead_,
						lookahead_ws_;
	SyntaxTree			syntax_root_;
	ubyte[] 			memory_pool_;
	size_t				pool_top_;
	Stack!(LRState) 	stack_;
	Stack!(Node)		node_stack_;
	Stack!(LRBranch)	branch_stack_;
	ParserException[]	recovered_errors_;
	bool				recover_from_errors_,
						detailed_errors_;

	version(ProfileConflicts) {
		uint[uint]		rr_conflict_counts_,
						sr_conflict_counts_,
						shift_failed_counts_,
						reduce_failed_counts_;
		uint			branch_stack_max_;
	}

	// grammar data
	GLRParser		ws_parser_;
	uint			first_nt_;
	RuleInfo[]		rule_infos_;
	string[][]		error_message_lists_;
	string[]		nt_names_,
					lexeme_names_;
	EntryInfo[][]	entry_infos_;
	ClassInfo[] 	syntax_node_cinfos_;

	/**************************************************************************************************

	**************************************************************************************************/
	this(GLRParser ws, uint tabw)
	{
		ws_parser_ = ws;
		tab_width_ = tabw;
		stack_.stack.length = LR_STACK_RESERVE;
		node_stack_.stack.length = NODE_STACK_RESERVE;
		branch_stack_.stack.length = BRANCH_STACK_RESERVE;
	}

	/**************************************************************************************************
		Gets overridden with a first-longest-match lexical analizer.
	**************************************************************************************************/
	bool function(string, out uint, out string) lexer;

	/**************************************************************************************************
		Gets overridden with the main parser function.
	**************************************************************************************************/
	bool parse(string input) { return false; }
	bool parseWS(ref string input) { return false; }

	/**************************************************************************************************

	**************************************************************************************************/
	bool isErrorSynced(uint state);

	/**************************************************************************************************

	**************************************************************************************************/
	T APDmin(T)(T a, T b) { return a<b?a:b; }
	uint[] lookaheadForNT(uint nt_index, uint state);

	/**************************************************************************************************
		Update line and column counter according to str
	**************************************************************************************************/
	void countLocation(string str, ref uint line, ref uint col)
	{
		dchar linefeed;
		for ( size_t p; p < str.length; )
		{
			dchar c = cast(dchar)str[p];
			if ( c & 0x80 )
				c = decode(str, p);
			else
				++p;

			switch ( c )
			{
				case '\n':
				case '\r':
					if ( linefeed == dchar.init || linefeed == c ) {
						++line;
						col = 1;
						linefeed = c;
					}
					else
						linefeed = dchar.init;
					break;
				case '\t':
					col += tab_width_-(col-1)%tab_width_;
					linefeed = dchar.init;
					break;
				default:
					++col;
					linefeed = dchar.init;
					break;
			}
		}
	}

	/**************************************************************************************************
		Initiates the parse call.
	**************************************************************************************************/
	final bool parse(string fname, string input, out SyntaxTree root, bool detailed=false, bool recover=false)
	{
		filename_ = fname;
		recover_from_errors_ = recover;
		detailed_errors_ = detailed;

		stack_.clear;
		node_stack_.clear;
		branch_stack_.clear;
		pool_top_ = 0;
		memory_pool_ = null;
		recovered_errors_ = null;

		if ( input.length > 1 )
		{
			if ( input[0 .. 2] == "\xfe\xff" ) {
				// UTF-16BE
				input = input[2 .. $];
			}
			else if ( input[0 .. 2] == "\xff\xfe" )
			{
				if ( input.length > 3 && input[2 .. 4] == "\x00\x00" ) {
					// UTF-32LE
					input = input[4 .. $];
				}
				else {
					// UTF-16LE
					input = input[2 .. $];
				}
			}
			else if ( input.length > 2 && input[0 .. 3] == "\xef\xbb\xbf" ) {
				// UTF-8
				input = input[3 .. $];
			}
			else if ( input.length > 3 && input[0 .. 4] == "\x00\x00\xfe\xff" ) {
				// UTF-32BE
				input = input[4 .. $];
			}
			else if ( input[0] > 0x7f )
				return false;
		}

		stack_ ~= LRState(0, 1, 1);
		if ( parse(input) )
		{
			if ( syntax_root_ !is null )
			{
				root = syntax_root_;
				debug
				{
					Stack!(SyntaxTree) st;
					st.push(root);
					while ( !st.empty )
					{
						SyntaxTree pn = st.pop;
						foreach ( c; pn._ST_children ) {
							c.parent = pn;
							st.push(c);
						}
					}
				}
			}
			return true;
		}
		return false;
	}

	/**************************************************************************************************
		Create a node for the syntax tree. Used by the main parse function.
	**************************************************************************************************/
	void createNode(uint line, uint column, uint rule_index, uint nt_count, uint nt_index)
	{
/*
		if ( pool_top >= syntax_tree_pool.length )
			syntax_tree_pool.length = syntax_tree_pool.length*2+1;
		auto pn = &syntax_tree_pool[pool_top];
		++pool_top;
*/
		auto pn = cast(SyntaxTree)syntax_node_cinfos_[nt_index].create();
		pn._ST_rule = rule_index;
		pn._ST_line_number = line;
		pn._ST_column_number = column;
		debug pn._ST_node_name = nt_names_[nt_index];

		if ( nt_count > 0 )
		{
			pn._ST_children.length = nt_count;
			foreach ( i, n; node_stack_.array[$-nt_count .. $] )
				pn._ST_children[i] = n.node;
			node_stack_.pop(nt_count);
		}
		else {
			pn._ST_match = match_;
			pn._ST_match_ws = match_ws_;
		}
		node_stack_ ~= Node(pn, false);
	}

	/**************************************************************************************************

	**************************************************************************************************/
	string ruleToString(RuleInfo* ri, int pos)
	{
		version(Tango)
			string str = format("{} ->", nt_names_[ri.nt_index]);
		else
			string str = format("%s ->", nt_names_[ri.nt_index]);

		foreach ( i, s; ri.symbols )
		{
			string name;
			if ( s == ALTERN )
				name = "ALTERN";
			else if ( s < FIRST_NT )
				name = lexeme_names_[s-EOS];
			else
				name = nt_names_[s-FIRST_NT];
			if ( i == pos )
				str ~= " .";
			version(Tango)
				str ~= format(" {}", name);
			else
				str ~= format(" %s", name);
		}
		if ( pos == ri.symbols.length )
			str ~= " .";
		return str;
	}

	/**************************************************************************************************
		Issue an error. Used by the main parse function.
	**************************************************************************************************/
	void error(string input, uint line, uint column, uint error_list, uint symbol, bool fatal=true)
	{
		// collect explicit error messages
		string errors;
		foreach ( i, err; error_message_lists_[error_list] )
		{
			if ( i > 0 )
				errors ~= "\n";
			errors ~= err;
		}

		// construct automatic error message
		// if no explicit error message available
		if ( errors.length == 0 )
		{
			bool[string] expected_symbols;
			EntryInfo[] eis = entry_infos_[stack_.top.index];
			foreach ( ei; eis )
			{
				RuleInfo* ri = &rule_infos_[ei.rule_index];
				if ( ei.pos < ri.symbols.length )
				{
					auto s = ri.symbols[ei.pos];
					if ( s < FIRST_NT )
						expected_symbols["\""~lexeme_names_[s-EOS]~"\""] = true;
					else
						expected_symbols[nt_names_[s-FIRST_NT]] = true;
				}
				else
				{
					foreach ( token; lookaheadForNT(ri.nt_index, stack_.top.index) ) {
						assert(token < FIRST_NT, __FILE__~"("~std.string.toString(__LINE__)~")");
						expected_symbols["\""~lexeme_names_[token-EOS]~"\""] = true;
					}
				}
			}

			string expected_str;
			auto last = expected_symbols.length-1;
			foreach ( i, symname; expected_symbols.keys )
			{
				if ( i > 0 )
				{
					if ( i == last )
						expected_str ~= " or ";
					else
						expected_str ~= ", ";
				}
				expected_str ~= symname;
			}
			version(Tango)
				errors = format("found \"{}\", expected {}", lookahead_, expected_str);
			else
				errors = format("found \"%s\", expected %s", lookahead_, expected_str);
		}

		// construct detail message
		string detail;
		if ( detailed_errors_ )
		{
			string			lr_stack;
			foreach ( st; stack_.array[1..$] )
			{
				version(Tango)
					lr_stack ~= format("---- State {}{} ({}:{}) ----\n", st.index, isErrorSynced(st.index)?"*":"", st.line, st.column);
				else
					lr_stack ~= format("---- State %d%s (%d:%d) ----\n", st.index, isErrorSynced(st.index)?"*":"", st.line, st.column);
				EntryInfo[] eis = entry_infos_[st.index];
				foreach ( ei; eis )
					lr_stack ~= ruleToString(&rule_infos_[ei.rule_index], ei.pos)~"\n";
			}

			string node_stack_str;
			foreach ( i, n; node_stack_.array )
			{
				if ( i > 0 )
					node_stack_str ~= " ";
				node_stack_str ~= nt_names_[rule_infos_[n.node._ST_rule].nt_index];
				if ( n.sync )
					node_stack_str ~= "*";
			}

			version(Tango)
				detail = format("input: {}\nlookahead: {}\nlexeme: {}\nAST node stack:\n{}\nLR stack:\n{}",
					substitute(substitute(input[0..$>MAX_INPUT_DUMP?MAX_INPUT_DUMP:$], "\r", "\\r"), "\n", "\\n"),
					lookahead_, lexeme_names_[symbol-EOS],
					node_stack_str, lr_stack
				);
			else
				detail = format("input: %s\nlookahead: %s\nlexeme: %s\nAST node stack:\n%s\nLR stack:\n%s",
					replace(replace(input[0..$>MAX_INPUT_DUMP?MAX_INPUT_DUMP:$], "\r", "\\r"), "\n", "\\n"),
					lookahead_, lexeme_names_[symbol-EOS],
					node_stack_str, lr_stack
				);
		}

		// throw error
		if ( fatal ) {
			version(Tango) Trace.formatln("");
			throw new ParserException(line, column-lookahead_.length, filename_, errors, detail);
		}
		else
		{
			version(Tango)
				debug(nonfatal) Trace.formatln("\n{}({}:{}): {}\n{}", filename_, line, column-lookahead_.length, errors, detail);
			else
				debug(nonfatal) writefln("\n%s(%d:%d): %s\n%s", filename_, line, column-lookahead_.length, errors, detail);
		}
	}
}

/**************************************************************************************************
	Generated parsers
**************************************************************************************************/
class MainGrammar : public GLRParser
{
	const ushort[]	action_base_ =
	[
		0,23,45,0,67,96,125,154,171,198,222,228,245,273,277,291,305,319,347,375,381,389,7,397,414,
		443,0,36,45,67,472,198,1,219,221,501,529,535,552,580,279,586,284,595,624,653,236,8,333,682,
		0,711,9,740,543,769,771,779,781,789,791,799,801,809,811,819,821,829,831,71,839,844,852,142,
		854,862,864,883,5,891,6,893,901,903
	];
	const ubyte[]  action_check_ =
	[
		3,0,0,26,32,84,50,50,0,0,0,0,0,0,0,52,26,0,0,0,0,0,0,0,1,1,22,47,0,78,80,1,1,1,1,1,1,1,84,
		27,1,1,1,1,1,1,1,2,28,84,84,1,27,2,2,2,2,2,2,2,84,28,2,2,2,2,2,2,2,4,29,84,84,2,84,4,4,4,4,
		4,4,4,84,29,4,4,4,4,4,4,4,69,69,69,69,4,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,
		5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,84,7,7,7,7,7,73,73,
		73,73,84,84,84,7,7,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,9,31,84,84,84,
		84,9,9,9,9,9,9,84,84,31,9,9,9,9,9,9,9,33,10,34,10,9,10,10,11,84,11,84,11,11,33,46,34,10,46,
		46,46,46,46,11,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,
		12,12,12,12,13,84,13,14,13,13,14,84,40,14,14,40,84,42,84,13,42,15,84,14,15,40,84,15,15,84,
		42,14,14,14,14,16,84,15,16,84,84,16,16,84,84,15,15,15,15,17,84,16,17,84,84,17,17,84,84,16,
		16,16,16,48,84,17,48,48,48,48,48,84,84,17,17,17,17,18,18,18,18,18,18,18,18,18,18,18,18,18,
		18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,18,19,84,19,84,19,19,20,84,20,20,20,20,84,84,
		21,19,21,21,21,21,20,20,23,84,23,23,23,23,21,21,84,84,84,84,84,84,23,23,24,24,24,24,24,24,
		24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,25,25,25,25,25,25,25,
		25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,30,30,30,30,30,30,30,30,
		30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,35,35,35,35,35,35,35,35,35,
		35,35,35,35,35,35,35,35,35,35,35,35,35,35,35,35,35,35,35,35,36,84,36,84,36,36,37,84,37,84,
		37,37,84,54,84,36,54,54,54,54,54,37,38,38,38,38,38,38,38,38,38,38,38,38,38,38,38,38,38,38,
		38,38,38,38,38,38,38,38,38,38,38,39,84,39,84,39,39,41,84,41,84,41,41,84,84,84,39,43,84,84,
		84,84,41,43,43,43,43,43,43,84,84,84,43,43,43,43,43,43,43,84,84,84,84,43,44,44,44,44,44,44,
		44,44,44,44,44,44,44,44,44,44,44,44,44,44,44,44,44,44,44,44,44,44,44,45,45,45,45,45,45,45,
		45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,49,49,49,49,49,49,49,49,
		49,49,49,49,49,49,49,49,49,49,49,49,49,49,49,49,49,49,49,49,49,51,51,51,51,51,51,51,51,51,
		51,51,51,51,51,51,51,51,51,51,51,51,51,51,51,51,51,51,51,51,53,53,53,53,53,53,53,53,53,53,
		53,53,53,53,53,53,53,53,53,53,53,53,53,53,53,53,53,53,53,55,84,56,55,84,56,55,55,56,56,57,
		84,58,57,84,58,57,57,58,58,59,84,60,59,84,60,59,59,60,60,61,84,62,61,84,62,61,61,62,62,63,
		84,64,63,84,64,63,63,64,64,65,84,66,65,84,66,65,65,66,66,67,84,68,67,84,68,67,67,68,68,70,
		84,84,70,84,71,70,70,71,71,71,71,71,72,84,74,72,84,74,72,72,74,74,75,84,76,75,84,76,75,75,
		76,76,84,84,84,84,84,84,74,74,74,74,84,77,84,84,77,75,75,77,77,79,84,81,79,84,81,79,79,81,
		81,82,84,83,82,84,83,82,82,83,83
	];
	const ushort[]	action_data_ =
	[
		0,129,258,295,287,384,267,179,258,258,258,258,258,258,258,266,295,258,258,258,258,258,258,
		258,129,258,135,135,258,207,209,258,258,258,258,258,258,258,384,296,258,258,258,258,258,
		258,258,257,289,384,384,258,296,257,257,257,257,257,257,257,384,289,257,257,257,257,257,
		257,257,276,288,384,384,257,384,276,276,276,276,276,276,133,384,158,276,276,276,276,276,
		276,276,311,311,311,311,276,385,385,134,385,385,385,385,385,385,385,385,385,385,385,385,
		385,385,385,385,385,385,385,385,385,385,385,385,385,385,386,386,386,386,386,386,386,386,
		386,386,386,386,386,386,386,386,386,386,386,135,386,386,386,386,386,386,386,386,386,297,
		297,384,297,297,297,297,297,142,143,144,145,384,384,384,297,297,387,387,387,137,387,387,
		387,387,387,387,387,387,387,387,387,387,387,387,387,387,387,387,387,387,387,387,387,387,
		387,275,288,384,384,384,384,275,275,275,275,275,275,384,384,158,275,275,275,275,275,275,
		275,290,139,294,280,275,140,280,281,384,281,384,281,281,290,265,294,280,265,175,177,265,
		265,281,388,388,388,388,388,388,141,388,388,388,388,388,388,388,388,388,388,388,388,135,
		142,143,144,145,388,388,388,388,388,282,384,282,300,282,282,300,384,277,300,300,277,384,
		279,384,282,279,301,384,300,301,277,384,301,301,384,279,300,300,300,300,302,384,301,302,
		384,384,302,302,384,384,301,301,301,301,303,384,302,303,384,384,303,303,384,384,302,302,
		302,302,265,384,303,265,175,177,265,265,384,384,303,303,303,303,389,389,389,389,389,389,
		147,389,389,389,389,389,389,389,389,389,389,389,389,389,389,389,389,389,389,389,389,389,
		389,284,384,284,384,284,284,298,384,298,298,298,298,384,384,286,284,286,150,286,286,298,
		298,299,384,299,299,299,299,152,286,384,384,384,384,384,384,299,299,385,385,153,385,385,
		385,385,385,385,385,385,385,385,385,385,385,385,385,385,385,385,385,385,385,385,385,385,
		385,385,390,390,390,390,390,390,390,390,390,390,390,390,390,390,390,390,390,154,155,135,
		142,143,144,145,390,390,390,390,390,391,391,391,391,391,391,391,391,391,391,391,391,391,
		391,391,391,391,154,155,135,142,143,144,145,391,391,391,391,391,387,387,387,164,387,387,
		387,387,387,387,387,387,387,387,387,387,387,387,387,387,387,387,387,387,387,387,387,387,
		387,285,384,285,384,285,285,278,384,278,384,278,278,384,265,384,285,265,175,177,265,265,
		278,389,389,389,389,389,389,167,389,389,389,389,389,389,389,389,389,389,389,389,389,389,
		389,389,389,389,389,389,389,389,283,384,283,384,283,283,139,384,280,384,140,280,384,384,
		384,283,172,384,384,384,384,280,186,187,188,189,190,191,384,384,384,192,193,135,312,312,
		312,312,384,384,384,384,197,392,129,258,392,392,392,392,392,258,258,258,258,258,258,258,
		392,392,258,258,258,258,258,258,258,392,392,392,392,258,387,387,387,174,387,387,387,387,
		387,387,387,387,387,387,387,387,387,387,387,387,387,387,387,387,387,387,387,387,387,393,
		129,258,393,393,393,393,393,258,258,258,258,258,258,258,393,393,258,258,258,258,258,258,
		258,393,393,393,393,258,394,129,258,394,394,394,394,394,258,258,258,258,258,258,258,394,
		394,258,258,258,258,258,258,258,394,394,394,394,258,389,389,389,389,389,389,182,389,389,
		389,389,389,389,389,389,389,389,389,389,389,389,389,389,389,389,389,389,389,389,264,384,
		263,264,384,263,264,264,263,263,260,384,269,260,384,269,260,260,269,269,270,384,271,270,
		384,271,270,270,271,271,272,384,273,272,384,273,272,272,273,273,274,384,292,274,384,292,
		274,274,292,292,293,384,256,293,384,256,293,293,256,256,259,384,268,259,384,268,259,259,
		268,268,262,384,384,262,384,265,262,262,265,175,177,265,265,261,384,310,261,384,310,261,
		261,310,310,308,384,304,308,384,304,308,308,304,304,384,384,384,384,384,384,203,206,208,
		210,384,305,384,384,305,204,205,305,305,306,384,307,306,384,307,306,306,307,307,309,384,
		291,309,384,291,309,309,291,291
	];
	const ubyte[]  goto_base_ =
	[
		0,1,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,2,2,0,0,16,0,0,0,2,28,3,0,0,0,0,0,0,0,0,0,16,0,46,
		3,0,2,3,3,39,0,28,0,0,28,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,35,0,22,29,0,0,0,0,0,0,0,0,0
	];
	const ubyte[]  goto_check_ =
	[
		0,0,1,44,44,46,48,4,6,6,10,10,12,12,21,29,31,6,6,22,47,12,12,12,25,25,41,41,51,51,25,54,25,
		25,25,25,30,30,71,49,49,73,30,49,30,30,30,30,43,74,84,43,43,84,84,84,84,84,84,84,84,43,84,
		43,84,84,84,43
	];
	const ubyte[]  goto_data_ =
	[
		3,4,2,45,4,57,56,43,8,10,40,41,18,10,37,35,32,20,21,23,48,20,21,38,28,10,42,41,52,4,29,55,
		33,20,21,34,28,10,72,50,4,74,31,53,33,20,21,34,66,83,84,67,68,84,84,84,84,84,84,84,84,70,
		84,71,84,84,84,73
	];

	debug(parser) string indent_;

	this(GLRParser ws=null, uint tab_width=4)
	{
		super(ws, tab_width);
		lexer = &mainLexer;
		first_nt_ = 32;
		nt_names_ =
		[
			"Expr","Deref","DotChain","RefExpr","Args","Register","RegName","Cast","Type",
			"BaseType","QuantList","Quantifier","TplParams","TplParams2","TplParam","Lit","StrLit",
			"Ident","FQNIdent","Integer","IntegerSuffix","Sign","!LRstart"
		];
		lexeme_names_ =
		[
			"EOS","\\*","\\(","\\)","\\.","\\[","\\]","\\.\\.","#(e[abcd]x|e[ds]i|e[bs]p|eip|efl)",
			"#([abcd]x|[ds]i|[bs]p|(cdefgs)s)","#[abcd][hl]","#st[0-7]","#mm[0-7]","#xmm[0-7]",
			"cast","!",",",
			"\"(([^\"\\\\]*(\\\\(['\"\\?\\\\abfnrtv]|(x[0-9a-fA-F]{2})|(u[0-9a-fA-F]{4})|(U[0-9a-fA-F]{8})))?)*)\"",
			"'(([^'\\\\]|(\\\\(['\"\\?\\\\abfnrtv]|(x[0-9a-fA-F]{2})|(u[0-9a-fA-F]{4})|(U[0-9a-fA-F]{8})))))'",
			"[a-zA-Z_][_a-zA-Z0-9]*","0[xX][0-9a-fA-F_]+","0[bB][01_]+","0[0-7_]+",
			"0|([1-9][0-9_]*)","L","u","U","[uU]","\\-"
		];
		entry_infos_ =
		[
			cast(EntryInfo[])[EntryInfo(2,0)],[EntryInfo(1,1),EntryInfo(2,0)],[EntryInfo(1,2)],[EntryInfo(57,1)],[
			EntryInfo(0,1),EntryInfo(20,0)],[EntryInfo(19,1)],[EntryInfo(19,2)],[EntryInfo(41,1)],[EntryInfo(19,3)],[
			EntryInfo(19,4)],[EntryInfo(21,1),EntryInfo(24,0)],[EntryInfo(25,1)],[EntryInfo(26,1),EntryInfo(27,1)
			,EntryInfo(28,1)],[EntryInfo(26,2)],[EntryInfo(44,1)],[EntryInfo(45,1)],[EntryInfo(46,1)],[
			EntryInfo(47,1)],[EntryInfo(28,2)],[EntryInfo(28,3)],[EntryInfo(42,1)],[EntryInfo(22,1),EntryInfo(43,1)
			,EntryInfo(30,0)],[EntryInfo(43,2)],[EntryInfo(43,3)],[EntryInfo(29,1)],[EntryInfo(29,2)],[
			EntryInfo(39,1)],[EntryInfo(40,1)],[EntryInfo(33,1)],[EntryInfo(29,3),EntryInfo(32,0)],[
			EntryInfo(31,1)],[EntryInfo(31,2),EntryInfo(32,0)],[EntryInfo(31,3)],[EntryInfo(34,1)],[
			EntryInfo(38,1)],[EntryInfo(29,4)],[EntryInfo(29,5)],[EntryInfo(22,2)],[EntryInfo(27,2)],[
			EntryInfo(27,3)],[EntryInfo(21,2)],[EntryInfo(23,1),EntryInfo(24,0)],[EntryInfo(23,2)],[
			EntryInfo(0,2),EntryInfo(56,0)],[EntryInfo(4,1),EntryInfo(2,0)],[EntryInfo(4,2)],[EntryInfo(4,3)
			,EntryInfo(9,0)],[EntryInfo(7,1)],[EntryInfo(7,2),EntryInfo(9,0)],[EntryInfo(8,1),EntryInfo(2,0)],[
			EntryInfo(10,1),EntryInfo(11,1)],[EntryInfo(10,2),EntryInfo(2,0)],[EntryInfo(10,3)],[EntryInfo(8,2)],[
			EntryInfo(8,3),EntryInfo(9,0)],[EntryInfo(8,4)],[EntryInfo(7,3)],[EntryInfo(4,4)],[EntryInfo(13,1)],[
			EntryInfo(14,1)],[EntryInfo(15,1)],[EntryInfo(16,1)],[EntryInfo(17,1)],[EntryInfo(18,1)],[
			EntryInfo(36,1)],[EntryInfo(37,1)],[EntryInfo(0,3)],[EntryInfo(3,1)],[EntryInfo(12,1)],[
			EntryInfo(55,1)],[EntryInfo(6,1)],[EntryInfo(5,1),EntryInfo(9,0)],[EntryInfo(5,2)],[EntryInfo(35,1)],[
			EntryInfo(35,2),EntryInfo(54,0)],[EntryInfo(48,1),EntryInfo(49,1),EntryInfo(52,1)],[EntryInfo(48,2)],[
			EntryInfo(49,2)],[EntryInfo(50,1)],[EntryInfo(50,2)],[EntryInfo(51,1)],[EntryInfo(51,2)],[
			EntryInfo(53,1)],[EntryInfo(35,3)]
		];
		rule_infos_ =
		[
			RuleInfo(true,3,3,0,[ 4097, 4103, 4098 ]),RuleInfo(true,2,1,1,[ 4, 4097 ]),
			RuleInfo(true,0,0,1,[  ]),RuleInfo(true,1,1,2,[ 4101 ]),RuleInfo(true,4,2,2,[ 5, 4096, 6, 4099 ]),
			RuleInfo(true,2,2,2,[ 4113, 4099 ]),RuleInfo(true,1,1,2,[ 4111 ]),
			RuleInfo(true,3,2,3,[ 7, 4113, 4099 ]),RuleInfo(true,4,2,3,[ 8, 4100, 9, 4099 ]),
			RuleInfo(true,0,0,3,[  ]),RuleInfo(true,3,2,4,[ 4096, 10, 4096 ]),RuleInfo(true,1,1,4,[ 4096 ]),
			RuleInfo(true,1,1,5,[ 4102 ]),RuleInfo(true,1,0,6,[ 11 ]),RuleInfo(true,1,0,6,[ 12 ]),
			RuleInfo(true,1,0,6,[ 13 ]),RuleInfo(true,1,0,6,[ 14 ]),RuleInfo(true,1,0,6,[ 15 ]),
			RuleInfo(true,1,0,6,[ 16 ]),RuleInfo(true,4,1,7,[ 17, 5, 4104, 6 ]),RuleInfo(true,0,0,7,[  ]),
			RuleInfo(true,2,2,8,[ 4105, 4106 ]),RuleInfo(true,2,2,9,[ 4114, 4108 ]),
			RuleInfo(true,2,2,10,[ 4107, 4106 ]),RuleInfo(true,0,0,10,[  ]),RuleInfo(true,1,0,11,[ 4 ]),
			RuleInfo(true,2,0,11,[ 8, 9 ]),RuleInfo(true,3,1,11,[ 8, 4115, 9 ]),
			RuleInfo(true,3,1,11,[ 8, 4104, 9 ]),RuleInfo(true,5,2,12,[ 18, 5, 4110, 4109, 6 ]),
			RuleInfo(true,0,0,12,[	]),RuleInfo(true,3,2,13,[ 19, 4110, 4109 ]),RuleInfo(true,0,0,13,[	]),
			RuleInfo(true,1,1,14,[ 4104 ]),RuleInfo(true,1,1,14,[ 4112 ]),
			RuleInfo(true,3,3,15,[ 4117, 4115, 4116 ]),RuleInfo(true,1,0,15,[ 20 ]),
			RuleInfo(true,1,0,15,[ 21 ]),RuleInfo(true,1,1,16,[ 4115 ]),RuleInfo(true,1,0,16,[ 20 ]),
			RuleInfo(true,1,0,16,[ 21 ]),RuleInfo(true,1,0,17,[ 22 ]),RuleInfo(true,1,1,18,[ 4113 ]),
			RuleInfo(true,3,2,18,[ 4114, 7, 4113 ]),RuleInfo(true,1,0,19,[ 23 ]),RuleInfo(true,1,0,19,[ 24 ]),
			RuleInfo(true,1,0,19,[ 25 ]),RuleInfo(true,1,0,19,[ 26 ]),RuleInfo(true,2,0,20,[ 27, 28 ]),
			RuleInfo(true,2,0,20,[ 27, 29 ]),RuleInfo(true,2,0,20,[ 28, 27 ]),RuleInfo(true,2,0,20,[ 29, 27 ]),
			RuleInfo(true,1,0,20,[ 27 ]),RuleInfo(true,1,0,20,[ 30 ]),RuleInfo(true,0,0,20,[  ]),
			RuleInfo(true,1,0,21,[ 31 ]),RuleInfo(true,0,0,21,[  ]),RuleInfo(true,1,1,22,[ 4096 ])
		];
		syntax_node_cinfos_ =
		[
			SyntaxTree.classinfo,SyntaxTree.classinfo,SyntaxTree.classinfo,SyntaxTree.classinfo,
			SyntaxTree.classinfo,SyntaxTree.classinfo,SyntaxTree.classinfo,SyntaxTree.classinfo,
			SyntaxTree.classinfo,SyntaxTree.classinfo,SyntaxTree.classinfo,SyntaxTree.classinfo,
			SyntaxTree.classinfo,SyntaxTree.classinfo,SyntaxTree.classinfo,SyntaxTree.classinfo,
			SyntaxTree.classinfo,SyntaxTree.classinfo,SyntaxTree.classinfo,SyntaxTree.classinfo,
			SyntaxTree.classinfo,SyntaxTree.classinfo,SyntaxTree.classinfo
		];
		error_message_lists_ = [
			cast(string[])null,
			["(%d) ( expected"],
			["(%d) Type expected"],
			["(%d) ) expected"],
			["(%d) ], type or size expected"],
			["(%d) ] expected"],
			["(%d) Template parameters expected"],
			["(%d) Template parameter expected"],
			["(%d) Expression expected after ("],
			["(%d) Arguments expected after ["],
			["(%d) Second slice argument expected"]
		];
	}

	uint[] lookaheadForNT(uint nt_index, uint state)
	{
		uint[] tokens;
		auto b = action_base_[state];
		auto m = APDmin(action_check_.length, cast(size_t)b+first_nt_);
		foreach ( i, check; action_check_[b .. m] )
		{
			if ( check == state && (action_data_[b+i] & 384) == 256 )
				tokens ~= i+EOS;
		}
		return tokens;
	}

	override bool isErrorSynced(uint state)
	{
		switch ( state )
		{
			case 0:
				return true;
			default:
				break;
		}
		return false;
	}

	override bool parse(string input)
	{
		debug(parser) indent_ ~= " ";
		scope(exit) debug(parser) indent_ = indent_[0..$-1];

		bool	fatal_errors = true;
		uint	line = 1,
				column = 1,
				symbol;

		void reduce(uint rule)
		{
			version(Tango)
				debug(parser) Trace.format("{}reduce {} {}\n", indent_, rule, ruleToString(&rule_infos_[rule], -1));
			else
				debug(parser) writefln("%sreduce %d %s", indent_, rule, ruleToString(&rule_infos_[rule], -1));
			auto ri = &rule_infos_[rule];
			uint	reduce_line,
					reduce_column;
			if ( ri.symbol_count > 0 ) {
				reduce_line = stack_.array[$-ri.symbol_count].line;
				reduce_column = stack_.array[$-ri.symbol_count].column;
				stack_.pop(ri.symbol_count);
			}
			else {
				reduce_line = stack_.top.line;
				reduce_column = stack_.top.column;
			}

			auto b = goto_base_[stack_.top.index];
			b += ri.nt_index;
			debug(parser)
			{
				if ( b < goto_check_.length && goto_check_[b] == stack_.top.index ) {
					stack_ ~= LRState(goto_data_[b], reduce_line, reduce_column);

				version(Tango)
					Trace.format("{}goto {}\n", indent_, stack_.top.index);
				else
					writefln("%sgoto %d", indent_, stack_.top.index);
				}
				else
					assert(0, __FILE__~"("~std.string.toString(__LINE__)~")");
			}
			else
				stack_ ~= LRState(goto_data_[b], reduce_line, reduce_column);
			if ( ri.ast_node )
				createNode(reduce_line, reduce_column, rule, ri.nt_count, ri.nt_index);
			else if ( ri.nt_count > 0 )
				node_stack_.pop(ri.nt_count);
		}

		void branch(uint action)
		{
			version(ProfileConflicts)
			{
				if ( branch_stack_.length > branch_stack_max )
					branch_stack_max = branch_stack_.length;
			}
			if ( (action & 128) > 0 )
			{
				version(ProfileConflicts)
					sr_conflict_counts[stack_.top.index]++;
				version(Tango) debug(parser) Trace.format("{}branch shift conflict\n", indent);
				else debug(parser) writefln("%sbranch shift conflict", indent);
			}
			else
			{
				version(ProfileConflicts)
					rr_conflict_counts_[stack_.top.index]++;
				version(Tango) debug(parser) Trace.format("{}branch reduce conflict\n", indent_);
				else debug(parser) writefln("%sbranch reduce conflict", indent_);
			}
			version(ProfileConflicts)
				branch_stack_ ~= LRBranch(
					stack_.dup, node_stack_.dup,
					input, lookahead_, lookahead_ws_,
					line, column, symbol, fatal_errors,
					action, stack_.top.index | (action & 384)
				);
			else
				branch_stack_ ~= LRBranch(
					stack_.dup, node_stack_.dup,
					input, lookahead_, lookahead_ws_,
					line, column, symbol, fatal_errors,
					action
				);
			fatal_errors = false;
		}

		string prev_input = input;
		parseLoop: while ( true )
		{
			if ( symbol == 0 )
			{
			readSymbol:
				match_ = lookahead_;
				match_ws_ = lookahead_ws_;
				lookahead_ws_ = input;
				static if ( is(typeof(WhitespaceGrammar) : GLRParser) )
					ws_parser_.parseWS(input);
				version(Tango)
					debug(lexer) Trace.format("WS: '{}'\n", lookahead_ws_[0 .. $-input.length]);
				else
					debug(lexer) writefln("WS: '%s'", lookahead_ws_[0 .. $-input.length]);
				if ( input.length == 0 ) {
					symbol = EOS;
					lookahead_ = null;
				}
				else if ( lexer(input, symbol, lookahead_) ) {
					symbol += FIRST_TOKEN;
					lookahead_ws_ = lookahead_ws_[0 .. $+lookahead_.length-input.length];
					countLocation(lookahead_ws_, line, column);
				}
				else
					throw new ParserException(line, column, filename_, "Invalid token", input[0..$>MAX_INPUT_DUMP?MAX_INPUT_DUMP:$]);
				prev_input = input;
				input = input[lookahead_.length..$];
			}
			auto state = stack_.top.index;
			auto b = action_base_[state];
			uint action = 384;
			b += symbol-EOS;
			if ( b < action_check_.length && action_check_[b] == state )
				action = action_data_[b];
		actionSwitch:
			debug(parser)
			{
				string node_stack_str;
				foreach ( n; node_stack_.array )
					node_stack_str ~= " "~n.node._ST_node_name~(n.sync?"*":"");
				version(Tango)
					Trace.format("\n{}state {}\n{}nodes {}\n{}lkahd ({}) {}\n{}input ({}:{}) {}\n",
						indent_, stack_.top.index,
						indent_, node_stack_str,
						indent_, symbol, lookahead_,
						indent_, line, column,
						substitute(substitute(input[0..$>MAX_INPUT_DUMP?MAX_INPUT_DUMP:$], "\r", "\\r"), "\n", "\\n")
					);
				else
					writefln("\n%sstate %d\n%snodes %s\n%slkahd (%d) %s\n%sinput (%d:%d) %s",
						indent_, stack_.top.index,
						indent_, node_stack_str,
						indent_, symbol, lookahead_,
						indent_, line, column,
						replace(replace(input[0..$>MAX_INPUT_DUMP?MAX_INPUT_DUMP:$], "\r", "\\r"), "\n", "\\n")
					);
			}

			switch ( action & 384 )
			{
				case 128:
					action &= 127;
					version(Tango) debug(parser) Trace.format("{}shift {}\n", indent_, action);
					else debug(parser) writefln("%sshift %d", indent_, action);
					stack_ ~= LRState(action, line, column);
					symbol = 0;
					continue parseLoop;
				case 256:
					action &= 127;
					version(Tango) debug(parser) Trace.format("{}reduce {} {}\n", indent_, action, ruleToString(&rule_infos_[action], -1));
					else debug(parser) writefln("%sreduce %d %s", indent_, action, ruleToString(&rule_infos_[action], -1));
					auto ri = &rule_infos_[action];
					uint	reduce_line,
							reduce_column;
					if ( ri.symbol_count > 0 ) {
						reduce_line = stack_.array[$-ri.symbol_count].line;
						reduce_column = stack_.array[$-ri.symbol_count].column;
						stack_.pop(ri.symbol_count);
					}
					else {
						reduce_line = stack_.array[$-1].line;
						reduce_column = stack_.array[$-1].column;
					}

					state = stack_.top.index;
					b = goto_base_[state];
					b += ri.nt_index;
					debug(parser)
					{
						if ( b < goto_check_.length && goto_check_[b] == state ) {
							stack_ ~= LRState(goto_data_[b], reduce_line, reduce_column);
						version(Tango)
							Trace.format("{}goto {}\n", indent_, stack_.top.index);
						else
							writefln("%sgoto %d", indent_, stack_.top.index);
						}
						else
							assert(0, __FILE__~"("~std.string.toString(__LINE__)~")");
					}
					else
						stack_ ~= LRState(goto_data_[b], reduce_line, reduce_column);
					if ( ri.ast_node )
						createNode(reduce_line, reduce_column, action, ri.nt_count, ri.nt_index);
					else if ( ri.nt_count > 0 )
						node_stack_.pop(ri.nt_count);

					continue parseLoop;
				case 384:
					action &= 127;
					if ( fatal_errors || action > 0 )
					{
						if ( recover_from_errors_ )
						{
							try error(prev_input, line, column, action, symbol);
							catch ( ParserException e )
								recovered_errors_ ~= e;
							version(Tango)
								debug(nonfatal) Trace.format("recovering from error:\n{}\n", recovered_errors_[$-1]);
							else
								debug(nonfatal) writefln("recovering from error:\n%s", recovered_errors_[$-1]);
							while ( !stack_.empty && !isErrorSynced(stack_.top.index) )
								stack_.pop;
							while ( !node_stack_.empty && !node_stack_.top.sync )
								node_stack_.pop;
							symbol = 0;
							continue parseLoop;
						}
						else
						{
							input = prev_input;
							foreach ( bs; branch_stack_.array ) {
								bs.stack.free;
								bs.node_stack.free;
							}
							branch_stack_.clear;
							error(input, line, column, action, symbol);
						}
					}
					else
					{
						debug(nonfatal) {
							input = prev_input;
							error(input, line, column, action, symbol, false);
						}
					}
					if ( branch_stack_.length == 0 ) {
						input = prev_input;
						return false;
					}
					auto prev = branch_stack_.popPtr;
					stack_.free;
					stack_			= prev.stack;
					node_stack_.free;
					node_stack_ 	= prev.node_stack;
					input			= prev.input;
					prev_input		= input;
					lookahead_		= prev.lookahead;
					lookahead_ws_	= prev.lookahead_ws;
					line			= prev.line;
					column			= prev.column;
					symbol			= prev.symbol;
					fatal_errors	= prev.fatal_errors;
					action			= prev.action;

					version(ProfileConflicts)
					{
						if ( (prev.last_conflict & 128) > 0 )
							shift_failed_counts[prev.last_conflict & 127]++;
						else
							reduce_failed_counts[prev.last_conflict & 127]++;
					}
					goto actionSwitch;
				default:
					break;
			}

			switch ( action )
			{
				case 0:
					version(Tango)
						debug(parser) Trace.format("{}accept\n", indent);
					else
						debug(parser) writefln("%saccept", indent);
					syntax_root_ = node_stack_.top.node;

					foreach ( bs; branch_stack_.array ) {
						bs.stack.free;
						bs.node_stack.free;
					}
					branch_stack_.clear;
					input = prev_input;
					return true;
				default:
					assert(0, __FILE__~"("~std.string.toString(__LINE__)~")");
			}
		}
		assert(0, __FILE__~"("~std.string.toString(__LINE__)~")");
	}
}

class WhitespaceGrammar : public GLRParser
{
	const ubyte[]  action_base_ =
	[
		0,0,2
	];
	const ubyte[]  action_check_ =
	[
		1,0,2
	];
	const ubyte[]  action_data_ =
	[
		4,3,0
	];
	const ubyte[]  goto_base_ =
	[
		0,0,0
	];
	const ubyte[]  goto_check_ =
	[
		0
	];
	const ubyte[]  goto_data_ =
	[
		2
	];

	debug(parser) string indent_;

	this(GLRParser ws=null, uint tab_width=4)
	{
		super(ws, tab_width);
		lexer = &wsLexer;
		first_nt_ = 5;
		nt_names_ =
		[
			"Whitespace","!LRstart"
		];
		lexeme_names_ =
		[
			"EOS","[\\t\\n\\r ]+"
		];
		entry_infos_ =
		[
			cast(EntryInfo[])[],[EntryInfo(0,1)],[EntryInfo(1,1)]
		];
		rule_infos_ =
		[
			RuleInfo(true,1,0,0,[ 4 ]),RuleInfo(true,1,1,1,[ 4096 ])
		];
		syntax_node_cinfos_ =
		[
			SyntaxTree.classinfo,SyntaxTree.classinfo
		];
		error_message_lists_ = [
			cast(string[])null
		];
	}

	uint[] lookaheadForNT(uint nt_index, uint state)
	{
		uint[] tokens;
		auto b = action_base_[state];
		auto m = APDmin(action_check_.length, cast(size_t)b+first_nt_);
		foreach ( i, check; action_check_[b .. m] )
		{
			if ( check == state && (action_data_[b+i] & 6) == 4 )
				tokens ~= i+EOS;
		}
		return tokens;
	}

	override bool isErrorSynced(uint state)
	{
		switch ( state )
		{
			case 0:
				return true;
			default:
				break;
		}
		return false;
	}

	override bool parseWS(ref string input)
	{
		stack_.clear;
		stack_ ~= LRState(0, 1, 1);

		debug(parser) indent_ ~= " ";
		scope(exit) debug(parser) indent_ = indent_[0..$-1];

		bool	fatal_errors = true;
		uint	line = 1,
				column = 1,
				symbol;

		void reduce(uint rule)
		{
			version(Tango)
				debug(parser) Trace.format("{}reduce {} {}\n", indent_, rule, ruleToString(&rule_infos_[rule], -1));
			else
				debug(parser) writefln("%sreduce %d %s", indent_, rule, ruleToString(&rule_infos_[rule], -1));
			auto ri = &rule_infos_[rule];
			uint	reduce_line,
					reduce_column;
			if ( ri.symbol_count > 0 ) {
				reduce_line = stack_.array[$-ri.symbol_count].line;
				reduce_column = stack_.array[$-ri.symbol_count].column;
				stack_.pop(ri.symbol_count);
			}
			else {
				reduce_line = stack_.top.line;
				reduce_column = stack_.top.column;
			}

			auto b = goto_base_[stack_.top.index];
			b += ri.nt_index;
			debug(parser)
			{
				if ( b < goto_check_.length && goto_check_[b] == stack_.top.index ) {
					stack_ ~= LRState(goto_data_[b], reduce_line, reduce_column);
				}
				else
					assert(0, __FILE__~"("~std.string.toString(__LINE__)~")");
			}
			else
				stack_ ~= LRState(goto_data_[b], reduce_line, reduce_column);
		}

		void branch(uint action)
		{
			version(ProfileConflicts)
			{
				if ( branch_stack_.length > branch_stack_max )
					branch_stack_max = branch_stack_.length;
			}
			if ( (action & 2) > 0 )
			{
				version(ProfileConflicts)
					sr_conflict_counts[stack_.top.index]++;
			}
			else
			{
				version(ProfileConflicts)
					rr_conflict_counts_[stack_.top.index]++;
			}
			version(ProfileConflicts)
				branch_stack_ ~= LRBranch(
					stack_.dup, node_stack_.dup,
					input, lookahead_, lookahead_ws_,
					line, column, symbol, fatal_errors,
					action, stack_.top.index | (action & 6)
				);
			else
				branch_stack_ ~= LRBranch(
					stack_.dup, node_stack_.dup,
					input, lookahead_, lookahead_ws_,
					line, column, symbol, fatal_errors,
					action
				);
			fatal_errors = false;
		}

		string prev_input = input;
		parseLoop: while ( true )
		{
			if ( symbol == 0 )
			{
			readSymbol:
				match_ = lookahead_;
				match_ws_ = lookahead_ws_;
				if ( input.length == 0 ) {
					symbol = EOS;
					lookahead_ = null;
				}
				else if ( lexer(input, symbol, lookahead_) ) {
					symbol += FIRST_TOKEN;
				}
				else
					return false;
				prev_input = input;
				input = input[lookahead_.length..$];
			}
			auto state = stack_.top.index;
			auto b = action_base_[state];
			uint action = 6;
			b += symbol-EOS;
			if ( b < action_check_.length && action_check_[b] == state )
				action = action_data_[b];
		actionSwitch:

			switch ( action & 6 )
			{
				case 2:
					action &= 1;
					stack_ ~= LRState(action, line, column);
					symbol = 0;
					continue parseLoop;
				case 4:
					action &= 1;
					auto ri = &rule_infos_[action];
					uint	reduce_line,
							reduce_column;
					if ( ri.symbol_count > 0 ) {
						reduce_line = stack_.array[$-ri.symbol_count].line;
						reduce_column = stack_.array[$-ri.symbol_count].column;
						stack_.pop(ri.symbol_count);
					}
					else {
						reduce_line = stack_.array[$-1].line;
						reduce_column = stack_.array[$-1].column;
					}

					state = stack_.top.index;
					b = goto_base_[state];
					b += ri.nt_index;
					debug(parser)
					{
						if ( b < goto_check_.length && goto_check_[b] == state ) {
							stack_ ~= LRState(goto_data_[b], reduce_line, reduce_column);
						}
						else
							assert(0, __FILE__~"("~std.string.toString(__LINE__)~")");
					}
					else
						stack_ ~= LRState(goto_data_[b], reduce_line, reduce_column);

					continue parseLoop;
				case 6:
					action &= 1;
					input = prev_input;
					if ( branch_stack_.length == 0 ) {
						input = prev_input;
						return false;
					}
					auto prev = branch_stack_.popPtr;
					stack_.free;
					stack_			= prev.stack;
					node_stack_.free;
					node_stack_ 	= prev.node_stack;
					input			= prev.input;
					prev_input		= input;
					lookahead_		= prev.lookahead;
					lookahead_ws_	= prev.lookahead_ws;
					line			= prev.line;
					column			= prev.column;
					symbol			= prev.symbol;
					fatal_errors	= prev.fatal_errors;
					action			= prev.action;

					version(ProfileConflicts)
					{
						if ( (prev.last_conflict & 2) > 0 )
							shift_failed_counts[prev.last_conflict & 1]++;
						else
							reduce_failed_counts[prev.last_conflict & 1]++;
					}
					goto actionSwitch;
				default:
					break;
			}

			switch ( action )
			{
				case 0:
					input = prev_input;
					return true;
				default:
					assert(0, __FILE__~"("~std.string.toString(__LINE__)~")");
			}
		}
		assert(0, __FILE__~"("~std.string.toString(__LINE__)~")");
	}
}


// generated code end
