//@@@ add
/***********************************************************************\
*                                 d3d10_sub.d                           *
*                                                                       *
*                       Windows API header module                       *
*                                                                       *
*                       Placed into public domain                       *
\***********************************************************************/

module win32.directx.d3d10_sub;


// from d3d10.d

enum D3D10_PRIMITIVE_TOPOLOGY {
	D3D10_PRIMITIVE_TOPOLOGY_UNDEFINED			= 0,
	D3D10_PRIMITIVE_TOPOLOGY_POINTLIST			= 1,
	D3D10_PRIMITIVE_TOPOLOGY_LINELIST			= 2,
	D3D10_PRIMITIVE_TOPOLOGY_LINESTRIP			= 3,
	D3D10_PRIMITIVE_TOPOLOGY_TRIANGLELIST		= 4,
	D3D10_PRIMITIVE_TOPOLOGY_TRIANGLESTRIP		= 5,
	D3D10_PRIMITIVE_TOPOLOGY_LINELIST_ADJ		= 10,
	D3D10_PRIMITIVE_TOPOLOGY_LINESTRIP_ADJ		= 11,
	D3D10_PRIMITIVE_TOPOLOGY_TRIANGLELIST_ADJ	= 12,
	D3D10_PRIMITIVE_TOPOLOGY_TRIANGLESTRIP_ADJ	= 13
}

enum D3D10_SRV_DIMENSION {
	D3D10_SRV_DIMENSION_UNKNOWN	= 0,
	D3D10_SRV_DIMENSION_BUFFER,
	D3D10_SRV_DIMENSION_TEXTURE1D,
	D3D10_SRV_DIMENSION_TEXTURE1DARRAY,
	D3D10_SRV_DIMENSION_TEXTURE2D,
	D3D10_SRV_DIMENSION_TEXTURE2DARRAY,
	D3D10_SRV_DIMENSION_TEXTURE2DMS,
	D3D10_SRV_DIMENSION_TEXTURE2DMSARRAY,
	D3D10_SRV_DIMENSION_TEXTURE3D,
	D3D10_SRV_DIMENSION_TEXTURECUBE
}


// from d3d10shader.d

enum D3D10_SHADER_VARIABLE_CLASS {
	D3D10_SVC_SCALAR,
	D3D10_SVC_VECTOR,
	D3D10_SVC_MATRIX_ROWS,
	D3D10_SVC_MATRIX_COLUMNS,
	D3D10_SVC_OBJECT,
	D3D10_SVC_STRUCT,
	D3D10_SVC_FORCE_DWORD = 0x7fffffff
}


enum D3D10_SHADER_VARIABLE_TYPE {
	D3D10_SVT_VOID = 0,
	D3D10_SVT_BOOL = 1,
	D3D10_SVT_INT = 2,
	D3D10_SVT_FLOAT = 3,
	D3D10_SVT_STRING = 4,
	D3D10_SVT_TEXTURE = 5,
	D3D10_SVT_TEXTURE1D = 6,
	D3D10_SVT_TEXTURE2D = 7,
	D3D10_SVT_TEXTURE3D = 8,
	D3D10_SVT_TEXTURECUBE = 9,
	D3D10_SVT_SAMPLER = 10,
	D3D10_SVT_PIXELSHADER = 15,
	D3D10_SVT_VERTEXSHADER = 16,
	D3D10_SVT_UINT = 19,
	D3D10_SVT_UINT8 = 20,
	D3D10_SVT_GEOMETRYSHADER = 21,
	D3D10_SVT_RASTERIZER = 22,
	D3D10_SVT_DEPTHSTENCIL = 23,
	D3D10_SVT_BLEND = 24,
	D3D10_SVT_BUFFER = 25,
	D3D10_SVT_CBUFFER = 26,
	D3D10_SVT_TBUFFER = 27,
	D3D10_SVT_TEXTURE1DARRAY = 28,
	D3D10_SVT_TEXTURE2DARRAY = 29,
	D3D10_SVT_RENDERTARGETVIEW = 30,
	D3D10_SVT_DEPTHSTENCILVIEW = 31,
	D3D10_SVT_TEXTURE2DMS = 32,
	D3D10_SVT_TEXTURE2DMSARRAY = 33,
	D3D10_SVT_TEXTURECUBEARRAY = 34,
	D3D10_SVT_FORCE_DWORD = 0x7fffffff
}

